# Class: DevUtilsContract


##   Constructors



\+ **new DevUtilsContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[DevUtilsContract](#class-devutilscontract)*

*Overrides void*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:3257](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L3257)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  DevUtilsContract.deployedBytecode |

**Returns:** *[DevUtilsContract](#class-devutilscontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:34

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:30

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:31

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:33

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:32

___

### `Static` contractName

▪ **contractName**: *string* = "DevUtils"

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:46](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L46)*

## Methods

###  EIP712_EXCHANGE_DOMAIN_HASH

▸ **EIP712_EXCHANGE_DOMAIN_HASH**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1597](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1597)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  chaiBridgeAddress

▸ **chaiBridgeAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1617](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1617)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  decodeAssetProxyId

▸ **decodeAssetProxyId**(`assetData`: string): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1643](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1643)*

Decode AssetProxy identifier

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-20, ERC-     721, ERC1155, or MultiAsset asset. |

**Returns:** *`ContractFunctionObj<string>`*

The AssetProxy identifier

___

###  decodeERC1155AssetData

▸ **decodeERC1155AssetData**(`assetData`: string): *`ContractFunctionObj<[string, string, BigNumber[], BigNumber[], string]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1675](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1675)*

Decode ERC-1155 asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-1155 set     of assets. |

**Returns:** *`ContractFunctionObj<[string, string, BigNumber[], BigNumber[], string]>`*

The ERC-1155 AssetProxy identifier, the address of the ERC-1155 contract hosting the assets, an array of the identifiers of the assets to be traded, an array of asset amounts to be traded, and callback data.  Each element of the arrays corresponds to the same-indexed element of the other array.  Return values specified as &#x60;memory&#x60; are returned as pointers to locations within the memory of the input parameter &#x60;assetData&#x60;.

___

###  decodeERC20AssetData

▸ **decodeERC20AssetData**(`assetData`: string): *`ContractFunctionObj<[string, string]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1713](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1713)*

Decode ERC-20 asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-20 asset. |

**Returns:** *`ContractFunctionObj<[string, string]>`*

The AssetProxy identifier, and the address of the ERC-20 contract hosting this asset.

___

###  decodeERC20BridgeAssetData

▸ **decodeERC20BridgeAssetData**(`assetData`: string): *`ContractFunctionObj<[string, string, string, string]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1745](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1745)*

Decode ERC20Bridge asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC20Bridge     asset |

**Returns:** *`ContractFunctionObj<[string, string, string, string]>`*

The ERC20BridgeProxy identifier, the address of the ERC20 token to transfer, the address of the bridge contract, and extra data to be passed to the bridge contract.

___

###  decodeERC721AssetData

▸ **decodeERC721AssetData**(`assetData`: string): *`ContractFunctionObj<[string, string, BigNumber]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1780](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1780)*

Decode ERC-721 asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-721     asset. |

**Returns:** *`ContractFunctionObj<[string, string, BigNumber]>`*

The ERC-721 AssetProxy identifier, the address of the ERC-721 contract hosting this asset, and the identifier of the specific asset to be traded.

___

###  decodeMultiAssetData

▸ **decodeMultiAssetData**(`assetData`: string): *`ContractFunctionObj<[string, BigNumber[], string[]]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1814](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1814)*

Decode multi-asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant data describing a multi-asset basket. |

**Returns:** *`ContractFunctionObj<[string, BigNumber[], string[]]>`*

The Multi-Asset AssetProxy identifier, an array of the amounts of the assets to be traded, and an array of the AssetProxy-compliant data describing each asset to be traded.  Each element of the arrays corresponds to the same-indexed element of the other array.

___

###  decodeStaticCallAssetData

▸ **decodeStaticCallAssetData**(`assetData`: string): *`ContractFunctionObj<[string, string, string, string]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1849](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1849)*

Decode StaticCall asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing a StaticCall     asset |

**Returns:** *`ContractFunctionObj<[string, string, string, string]>`*

The StaticCall AssetProxy identifier, the target address of the StaticCAll, the data to be passed to the target address, and the expected Keccak-256 hash of the static call return data.

___

###  decodeZeroExTransactionData

▸ **decodeZeroExTransactionData**(`transactionData`: string): *`ContractFunctionObj<[string, Array<object>, BigNumber[], string[]]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1884](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1884)*

Decodes the call data for an Exchange contract method call.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transactionData` | string | ABI-encoded calldata for an Exchange     contract     method call. |

**Returns:** *`ContractFunctionObj<[string, Array<object>, BigNumber[], string[]]>`*

The name of the function called, and the parameters it was     given.  For single-order fills and cancels, the arrays will have     just one element.

___

###  dydxBridgeAddress

▸ **dydxBridgeAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1981](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1981)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  encodeERC1155AssetData

▸ **encodeERC1155AssetData**(`tokenAddress`: string, `tokenIds`: `BigNumber`[], `tokenValues`: `BigNumber`[], `callbackData`: string): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2011](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2011)*

Encode ERC-1155 asset data into the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The address of the ERC-1155 contract hosting the     asset(s) to be traded. |
`tokenIds` | `BigNumber`[] | The identifiers of the specific assets to be traded. |
`tokenValues` | `BigNumber`[] | The amounts of each asset to be traded. |
`callbackData` | string | Data to be passed to receiving contracts when a transfer     is performed. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant asset data describing the set of assets.

___

###  encodeERC20AssetData

▸ **encodeERC20AssetData**(`tokenAddress`: string): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2056](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2056)*

Encode ERC-20 asset data into the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The address of the ERC-20 contract hosting the asset to     be traded. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant data describing the asset.

___

###  encodeERC721AssetData

▸ **encodeERC721AssetData**(`tokenAddress`: string, `tokenId`: `BigNumber`): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2089](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2089)*

Encode ERC-721 asset data into the format described in the AssetProxy specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The address of the ERC-721 contract hosting the asset to     be traded. |
`tokenId` | `BigNumber` | The identifier of the specific asset to be traded. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant asset data describing the asset.

___

###  encodeMultiAssetData

▸ **encodeMultiAssetData**(`amounts`: `BigNumber`[], `nestedAssetData`: string[]): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2123](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2123)*

Encode data for multiple assets, per the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`amounts` | `BigNumber`[] | The amounts of each asset to be traded. |
`nestedAssetData` | string[] | AssetProxy-compliant data describing each asset to be     traded. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant data describing the set of assets.

___

###  encodeStaticCallAssetData

▸ **encodeStaticCallAssetData**(`staticCallTargetAddress`: string, `staticCallData`: string, `expectedReturnDataHash`: string): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2159](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2159)*

Encode StaticCall asset data into the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`staticCallTargetAddress` | string | Target address of StaticCall. |
`staticCallData` | string | Data that will be passed to staticCallTargetAddress in     the StaticCall. |
`expectedReturnDataHash` | string | Expected Keccak-256 hash of the StaticCall     return data. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant asset data describing the set of assets.

___

###  erc1155ProxyAddress

▸ **erc1155ProxyAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2195](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2195)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  erc20ProxyAddress

▸ **erc20ProxyAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2215](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2215)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  erc721ProxyAddress

▸ **erc721ProxyAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2235](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2235)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  exchangeAddress

▸ **exchangeAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2255](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2255)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1582](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1582)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1574](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1574)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getAssetProxyAllowance

▸ **getAssetProxyAllowance**(`ownerAddress`: string, `assetData`: string): *`ContractTxFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2282](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2282)*

Returns the number of asset(s) (described by assetData) that the corresponding AssetProxy contract is authorized to spend.  When the asset data contains multiple assets (eg for Multi-Asset), the return value indicates how many complete "baskets" of those assets may be spent by all of the corresponding AssetProxy contracts.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string | Details of asset, encoded per the AssetProxy contract     specification. |

**Returns:** *`ContractTxFunctionObj<BigNumber>`*

Number of assets (or asset baskets) that the corresponding AssetProxy is authorized to spend.

___

###  getBalance

▸ **getBalance**(`ownerAddress`: string, `assetData`: string): *`ContractTxFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2337](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2337)*

Returns the owner's balance of the assets(s) specified in assetData.  When the asset data contains multiple assets (eg in ERC1155 or Multi-Asset), the return value indicates how many complete "baskets" of those assets are owned by owner.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string | Details of asset, encoded per the AssetProxy contract     specification. |

**Returns:** *`ContractTxFunctionObj<BigNumber>`*

Number of assets (or asset baskets) held by owner.

___

###  getBalanceAndAssetProxyAllowance

▸ **getBalanceAndAssetProxyAllowance**(`ownerAddress`: string, `assetData`: string): *`ContractTxFunctionObj<[BigNumber, BigNumber]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2392](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2392)*

Calls getBalance() and getAllowance() for assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string | Details of asset, encoded per the AssetProxy contract     specification. |

**Returns:** *`ContractTxFunctionObj<[BigNumber, BigNumber]>`*

Number of assets (or asset baskets) held by owner, and number of assets (or asset baskets) that the corresponding AssetProxy is authorized to spend.

___

###  getBatchAssetProxyAllowances

▸ **getBatchAssetProxyAllowances**(`ownerAddress`: string, `assetData`: string[]): *`ContractTxFunctionObj<BigNumber[]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2453](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2453)*

Calls getAssetProxyAllowance() for each element of assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |

**Returns:** *`ContractTxFunctionObj<BigNumber[]>`*

An array of asset allowances from getAllowance(), with each element corresponding to the same-indexed element in the assetData input.

___

###  getBatchBalances

▸ **getBatchBalances**(`ownerAddress`: string, `assetData`: string[]): *`ContractTxFunctionObj<BigNumber[]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2508](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2508)*

Calls getBalance() for each element of assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |

**Returns:** *`ContractTxFunctionObj<BigNumber[]>`*

Array of asset balances from getBalance(), with each element corresponding to the same-indexed element in the assetData input.

___

###  getBatchBalancesAndAssetProxyAllowances

▸ **getBatchBalancesAndAssetProxyAllowances**(`ownerAddress`: string, `assetData`: string[]): *`ContractTxFunctionObj<[BigNumber[], BigNumber[]]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2563](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2563)*

Calls getBatchBalances() and getBatchAllowances() for each element of assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |

**Returns:** *`ContractTxFunctionObj<[BigNumber[], BigNumber[]]>`*

An array of asset balances from getBalance(), and an array of asset allowances from getAllowance(), with each element corresponding to the same-indexed element in the assetData input.

___

###  getEthBalances

▸ **getEthBalances**(`addresses`: string[]): *`ContractFunctionObj<BigNumber[]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2622](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2622)*

Batch fetches ETH balances

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`addresses` | string[] | Array of addresses. |

**Returns:** *`ContractFunctionObj<BigNumber[]>`*

Array of ETH balances.

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1567](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1567)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getOrderHash

▸ **getOrderHash**(`order`: object, `chainId`: `BigNumber`, `exchange`: string): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2643](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2643)*

**Parameters:**

Name | Type |
------ | ------ |
`order` | object |
`chainId` | `BigNumber` |
`exchange` | string |

**Returns:** *`ContractFunctionObj<string>`*

___

###  getOrderRelevantState

▸ **getOrderRelevantState**(`order`: object, `signature`: string): *`ContractTxFunctionObj<[object, BigNumber, boolean]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2699](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2699)*

Fetches all order-relevant information needed to validate if the supplied order is fillable.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | The order structure. |
`signature` | string | Signature provided by maker that proves the order's     authenticity. `0x01` can always be provided if the signature does not     need to be validated. |

**Returns:** *`ContractTxFunctionObj<[object, BigNumber, boolean]>`*

The orderInfo (hash, status, and &#x60;takerAssetAmount&#x60; already filled for the given order), fillableTakerAssetAmount (amount of the order&#x27;s &#x60;takerAssetAmount&#x60; that is fillable given all on-chain state), and isValidSignature (validity of the provided signature). NOTE: If the &#x60;takerAssetData&#x60; encodes data for multiple assets, &#x60;fillableTakerAssetAmount&#x60; will represent a &quot;scaled&quot; amount, meaning it must be multiplied by all the individual asset amounts within the &#x60;takerAssetData&#x60; to get the final amount of each asset that can be filled.

___

###  getOrderRelevantStates

▸ **getOrderRelevantStates**(`orders`: `Array<object>`, `signatures`: string[]): *`ContractTxFunctionObj<[Array<object>, BigNumber[], boolean[]]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2787](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2787)*

Fetches all order-relevant information needed to validate if the supplied orders are fillable.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order structures. |
`signatures` | string[] | Array of signatures provided by makers that prove the     authenticity of the orders. `0x01` can always be provided if a signature     does not need to be validated. |

**Returns:** *`ContractTxFunctionObj<[Array<object>, BigNumber[], boolean[]]>`*

The ordersInfo (array of the hash, status, and &#x60;takerAssetAmount&#x60; already filled for each order), fillableTakerAssetAmounts (array of amounts for each order&#x27;s &#x60;takerAssetAmount&#x60; that is fillable given all on-chain state), and isValidSignature (array containing the validity of each provided signature). NOTE: If the &#x60;takerAssetData&#x60; encodes data for multiple assets, each element of &#x60;fillableTakerAssetAmounts&#x60; will represent a &quot;scaled&quot; amount, meaning it must be multiplied by all the individual asset amounts within the &#x60;takerAssetData&#x60; to get the final amount of each asset that can be filled.

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:1590](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L1590)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getSimulatedOrderMakerTransferResults

▸ **getSimulatedOrderMakerTransferResults**(`order`: object, `takerAddress`: string, `takerAssetFillAmount`: `BigNumber`): *`ContractTxFunctionObj<number>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2883](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2883)*

Simulates the maker transfers within an order and returns the index of the first failed transfer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | The order to simulate transfers for. |
`takerAddress` | string | The address of the taker that will fill the order. |
`takerAssetFillAmount` | `BigNumber` | The amount of takerAsset that the taker wished     to fill. |

**Returns:** *`ContractTxFunctionObj<number>`*

The index of the first failed transfer (or 4 if all transfers are successful).

___

###  getSimulatedOrderTransferResults

▸ **getSimulatedOrderTransferResults**(`order`: object, `takerAddress`: string, `takerAssetFillAmount`: `BigNumber`): *`ContractTxFunctionObj<number>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:2964](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L2964)*

Simulates all of the transfers within an order and returns the index of the first failed transfer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | The order to simulate transfers for. |
`takerAddress` | string | The address of the taker that will fill the order. |
`takerAssetFillAmount` | `BigNumber` | The amount of takerAsset that the taker wished     to fill. |

**Returns:** *`ContractTxFunctionObj<number>`*

The index of the first failed transfer (or 4 if all transfers are successful).

___

###  getSimulatedOrdersTransferResults

▸ **getSimulatedOrdersTransferResults**(`orders`: `Array<object>`, `takerAddresses`: string[], `takerAssetFillAmounts`: `BigNumber`[]): *`ContractTxFunctionObj<number[]>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:3046](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L3046)*

Simulates all of the transfers for each given order and returns the indices of each first failed transfer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of orders to individually simulate transfers for. |
`takerAddresses` | string[] | Array of addresses of takers that will fill each     order. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of amounts of takerAsset that will be     filled for each order. |

**Returns:** *`ContractTxFunctionObj<number[]>`*

The indices of the first failed transfer (or 4 if all transfers are successful) for each order.

___

###  getTransactionHash

▸ **getTransactionHash**(`transaction`: object, `chainId`: `BigNumber`, `exchange`: string): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:3115](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L3115)*

**Parameters:**

Name | Type |
------ | ------ |
`transaction` | object |
`chainId` | `BigNumber` |
`exchange` | string |

**Returns:** *`ContractFunctionObj<string>`*

___

###  getTransferableAssetAmount

▸ **getTransferableAssetAmount**(`ownerAddress`: string, `assetData`: string): *`ContractTxFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:3160](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L3160)*

Gets the amount of an asset transferable by the maker of an order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Address of the owner of the asset. |
`assetData` | string | Description of tokens, per the AssetProxy contract     specification. |

**Returns:** *`ContractTxFunctionObj<BigNumber>`*

The amount of the asset tranferable by the owner. NOTE: If the &#x60;assetData&#x60; encodes data for multiple assets, the &#x60;transferableAssetAmount&#x60; will represent the amount of times the entire &#x60;assetData&#x60; can be transferred. To calculate the total individual transferable amounts, this scaled &#x60;transferableAmount&#x60; must be multiplied by the individual asset amounts located within the &#x60;assetData&#x60;.

___

###  revertIfInvalidAssetData

▸ **revertIfInvalidAssetData**(`assetData`: string): *`ContractFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:3212](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L3212)*

Reverts if assetData is not of a valid format for its given proxy id.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy compliant asset data.  |

**Returns:** *`ContractFunctionObj<void>`*

___

###  staticCallProxyAddress

▸ **staticCallProxyAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:3238](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L3238)*

**Returns:** *`ContractFunctionObj<string>`*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:182](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L182)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `exchange_`: string, `chaiBridge_`: string, `dydxBridge_`: string): *`Promise<DevUtilsContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:131](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L131)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`exchange_` | string |
`chaiBridge_` | string |
`dydxBridge_` | string |

**Returns:** *`Promise<DevUtilsContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `exchange_`: string, `chaiBridge_`: string, `dydxBridge_`: string): *`Promise<DevUtilsContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:48](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L48)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`exchange_` | string |
`chaiBridge_` | string |
`dydxBridge_` | string |

**Returns:** *`Promise<DevUtilsContract>`*

___

### `Static` deployWithLibrariesFrom0xArtifactAsync

▸ **deployWithLibrariesFrom0xArtifactAsync**(`artifact`: `ContractArtifact`, `libraryArtifacts`: object, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `exchange_`: string, `chaiBridge_`: string, `dydxBridge_`: string): *`Promise<DevUtilsContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/dev_utils.ts:86](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/dev_utils.ts#L86)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` |
`libraryArtifacts` | object |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`exchange_` | string |
`chaiBridge_` | string |
`dydxBridge_` | string |

**Returns:** *`Promise<DevUtilsContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:44

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: ERC20TokenContract


##   Constructors



\+ **new ERC20TokenContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[ERC20TokenContract](#class-erc20tokencontract)*

*Overrides void*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:735](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L735)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  ERC20TokenContract.deployedBytecode |

**Returns:** *[ERC20TokenContract](#class-erc20tokencontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:34

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:30

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:31

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:33

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:32

___

### `Static` contractName

▪ **contractName**: *string* = "ERC20Token"

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:66](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L66)*

## Methods

###  allowance

▸ **allowance**(`_owner`: string, `_spender`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:428](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L428)*

**Parameters:**

Name | Type |
------ | ------ |
`_owner` | string |
`_spender` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  approve

▸ **approve**(`_spender`: string, `_value`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:456](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L456)*

`msg.sender` approves `_spender` to spend `_value` tokens

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_spender` | string | The address of the account able to transfer the tokens |
`_value` | `BigNumber` | The amount of wei to be approved for transfer |

**Returns:** *`ContractTxFunctionObj<boolean>`*

Always true if the call has enough gas to complete execution

___

###  balanceOf

▸ **balanceOf**(`_owner`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:509](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L509)*

Query the balance of owner

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_owner` | string | The address from which the balance will be retrieved |

**Returns:** *`ContractFunctionObj<BigNumber>`*

Balance of owner

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:413](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L413)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:405](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L405)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:398](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L398)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [ERC20TokenEvents](#enumeration-erc20tokenevents), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:719](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L719)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[ERC20TokenEventArgs](#erc20tokeneventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [ERC20TokenEvents](#enumeration-erc20tokenevents) | The ERC20Token contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:421](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L421)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [ERC20TokenEvents](#enumeration-erc20tokenevents), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:674](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L674)*

Subscribe to an event type emitted by the ERC20Token contract.

**Type parameters:**

▪ **ArgsType**: *[ERC20TokenEventArgs](#erc20tokeneventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [ERC20TokenEvents](#enumeration-erc20tokenevents) | - | The ERC20Token contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  totalSupply

▸ **totalSupply**(): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:534](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L534)*

Query total supply of token

**Returns:** *`ContractFunctionObj<BigNumber>`*

Total supply of token

___

###  transfer

▸ **transfer**(`_to`: string, `_value`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:560](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L560)*

send `value` token to `to` from `msg.sender`

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_to` | string | The address of the recipient |
`_value` | `BigNumber` | The amount of token to be transferred |

**Returns:** *`ContractTxFunctionObj<boolean>`*

True if transfer was successful

___

###  transferFrom

▸ **transferFrom**(`_from`: string, `_to`: string, `_value`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:615](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L615)*

send `value` token to `to` from `from` on the condition it is approved by `from`

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The address of the sender |
`_to` | string | The address of the recipient |
`_value` | `BigNumber` | The amount of token to be transferred |

**Returns:** *`ContractTxFunctionObj<boolean>`*

True if transfer was successful

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:700](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L700)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:707](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L707)*

Cancels all existing subscriptions

**Returns:** *void*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:172](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L172)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC20TokenContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:128](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L128)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC20TokenContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC20TokenContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:69](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L69)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC20TokenContract>`*

___

### `Static` deployWithLibrariesFrom0xArtifactAsync

▸ **deployWithLibrariesFrom0xArtifactAsync**(`artifact`: `ContractArtifact`, `libraryArtifacts`: object, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC20TokenContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:95](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L95)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` |
`libraryArtifacts` | object |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC20TokenContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:44

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: ERC721TokenContract


##   Constructors



\+ **new ERC721TokenContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[ERC721TokenContract](#class-erc721tokencontract)*

*Overrides void*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:995](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L995)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  ERC721TokenContract.deployedBytecode |

**Returns:** *[ERC721TokenContract](#class-erc721tokencontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:34

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:30

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:31

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:33

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:32

___

### `Static` contractName

▪ **contractName**: *string* = "ERC721Token"

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:76](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L76)*

## Methods

###  approve

▸ **approve**(`_approved`: string, `_tokenId`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:525](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L525)*

The zero address indicates there is no approved address.
Throws unless `msg.sender` is the current NFT owner, or an authorized
operator of the current owner.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_approved` | string | The new approved NFT controller |
`_tokenId` | `BigNumber` | The NFT to approve  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  balanceOf

▸ **balanceOf**(`_owner`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:579](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L579)*

NFTs assigned to the zero address are considered invalid, and this
function throws for queries about the zero address.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_owner` | string | An address for whom to query the balance |

**Returns:** *`ContractFunctionObj<BigNumber>`*

The number of NFTs owned by &#x60;_owner&#x60;, possibly zero

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:503](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L503)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:495](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L495)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getApproved

▸ **getApproved**(`_tokenId`: `BigNumber`): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:605](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L605)*

Throws if `_tokenId` is not a valid NFT.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_tokenId` | `BigNumber` | The NFT to find the approved address for |

**Returns:** *`ContractFunctionObj<string>`*

The approved address for this NFT, or the zero address if there is none

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:488](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L488)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [ERC721TokenEvents](#enumeration-erc721tokenevents), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:979](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L979)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[ERC721TokenEventArgs](#erc721tokeneventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [ERC721TokenEvents](#enumeration-erc721tokenevents) | The ERC721Token contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:511](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L511)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  isApprovedForAll

▸ **isApprovedForAll**(`_owner`: string, `_operator`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:626](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L626)*

**Parameters:**

Name | Type |
------ | ------ |
`_owner` | string |
`_operator` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  ownerOf

▸ **ownerOf**(`_tokenId`: `BigNumber`): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:654](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L654)*

NFTs assigned to zero address are considered invalid, and queries
about them do throw.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_tokenId` | `BigNumber` | The identifier for an NFT |

**Returns:** *`ContractFunctionObj<string>`*

The address of the owner of the NFT

___

###  safeTransferFrom1

▸ **safeTransferFrom1**(`_from`: string, `_to`: string, `_tokenId`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:682](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L682)*

This works identically to the other function with an extra data parameter,
except this function just sets data to "".

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The current owner of the NFT |
`_to` | string | The new owner |
`_tokenId` | `BigNumber` | The NFT to transfer  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  safeTransferFrom2

▸ **safeTransferFrom2**(`_from`: string, `_to`: string, `_tokenId`: `BigNumber`, `_data`: string): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:748](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L748)*

Throws unless `msg.sender` is the current owner, an authorized
operator, or the approved address for this NFT. Throws if `_from` is
not the current owner. Throws if `_to` is the zero address. Throws if
`_tokenId` is not a valid NFT. When transfer is complete, this function
checks if `_to` is a smart contract (code size > 0). If so, it calls
`onERC721Received` on `_to` and throws if the return value is not
`bytes4(keccak256("onERC721Received(address,address,uint256,bytes)"))`.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The current owner of the NFT |
`_to` | string | The new owner |
`_tokenId` | `BigNumber` | The NFT to transfer |
`_data` | string | Additional data with no specified format, sent in call to `_to`  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setApprovalForAll

▸ **setApprovalForAll**(`_operator`: string, `_approved`: boolean): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:814](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L814)*

Emits the ApprovalForAll event. The contract MUST allow
multiple operators per owner.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_operator` | string | Address to add to the set of authorized operators |
`_approved` | boolean | True if the operator is approved, false to revoke approval  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [ERC721TokenEvents](#enumeration-erc721tokenevents), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:934](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L934)*

Subscribe to an event type emitted by the ERC721Token contract.

**Type parameters:**

▪ **ArgsType**: *[ERC721TokenEventArgs](#erc721tokeneventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [ERC721TokenEvents](#enumeration-erc721tokenevents) | - | The ERC721Token contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  transferFrom

▸ **transferFrom**(`_from`: string, `_to`: string, `_tokenId`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:871](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L871)*

Throws unless `msg.sender` is the current owner, an authorized
operator, or the approved address for this NFT. Throws if `_from` is
not the current owner. Throws if `_to` is the zero address. Throws if
`_tokenId` is not a valid NFT.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The current owner of the NFT |
`_to` | string | The new owner |
`_tokenId` | `BigNumber` | The NFT to transfer  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:960](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L960)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:967](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L967)*

Cancels all existing subscriptions

**Returns:** *void*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:182](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L182)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC721TokenContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:138](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L138)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC721TokenContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC721TokenContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:79](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L79)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC721TokenContract>`*

___

### `Static` deployWithLibrariesFrom0xArtifactAsync

▸ **deployWithLibrariesFrom0xArtifactAsync**(`artifact`: `ContractArtifact`, `libraryArtifacts`: object, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC721TokenContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:105](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L105)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` |
`libraryArtifacts` | object |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC721TokenContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:44

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: ExchangeContract


##   Constructors



\+ **new ExchangeContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[ExchangeContract](#class-exchangecontract)*

*Overrides void*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:6007](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L6007)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  ExchangeContract.deployedBytecode |

**Returns:** *[ExchangeContract](#class-exchangecontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:34

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:30

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:31

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:33

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:32

___

### `Static` contractName

▪ **contractName**: *string* = "Exchange"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:132](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L132)*

## Methods

###  EIP1271_MAGIC_VALUE

▸ **EIP1271_MAGIC_VALUE**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3228](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3228)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  EIP712_EXCHANGE_DOMAIN_HASH

▸ **EIP712_EXCHANGE_DOMAIN_HASH**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3248](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3248)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  allowedValidators

▸ **allowedValidators**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3268](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3268)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  batchCancelOrders

▸ **batchCancelOrders**(`orders`: `Array<object>`): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3294](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3294)*

Executes multiple calls of cancelOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  batchExecuteTransactions

▸ **batchExecuteTransactions**(`transactions`: `Array<object>`, `signatures`: string[]): *`ContractTxFunctionObj<string[]>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3366](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3366)*

Executes a batch of Exchange method calls in the context of signer(s).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transactions` | `Array<object>` | Array of 0x transaction structures. |
`signatures` | string[] | Array of proofs that transactions have been signed by     signer(s). |

**Returns:** *`ContractTxFunctionObj<string[]>`*

returnData Array containing ABI encoded return data for each of the underlying Exchange function calls.

___

###  batchFillOrKillOrders

▸ **batchFillOrKillOrders**(`orders`: `Array<object>`, `takerAssetFillAmounts`: `BigNumber`[], `signatures`: string[]): *`ContractTxFunctionObj<Array<object>>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3431](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3431)*

Executes multiple calls of fillOrKillOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of desired amounts of takerAsset to sell     in orders. |
`signatures` | string[] | Proofs that orders have been created by makers. |

**Returns:** *`ContractTxFunctionObj<Array<object>>`*

fillResults Array of amounts filled and fees paid by makers and taker.

___

###  batchFillOrders

▸ **batchFillOrders**(`orders`: `Array<object>`, `takerAssetFillAmounts`: `BigNumber`[], `signatures`: string[]): *`ContractTxFunctionObj<Array<object>>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3535](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3535)*

Executes multiple calls of fillOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of desired amounts of takerAsset to sell     in orders. |
`signatures` | string[] | Proofs that orders have been created by makers. |

**Returns:** *`ContractTxFunctionObj<Array<object>>`*

fillResults Array of amounts filled and fees paid by makers and taker.

___

###  batchFillOrdersNoThrow

▸ **batchFillOrdersNoThrow**(`orders`: `Array<object>`, `takerAssetFillAmounts`: `BigNumber`[], `signatures`: string[]): *`ContractTxFunctionObj<Array<object>>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3639](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3639)*

Executes multiple calls of fillOrder. If any fill reverts, the error is caught and ignored.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of desired amounts of takerAsset to sell     in orders. |
`signatures` | string[] | Proofs that orders have been created by makers. |

**Returns:** *`ContractTxFunctionObj<Array<object>>`*

fillResults Array of amounts filled and fees paid by makers and taker.

___

###  batchMatchOrders

▸ **batchMatchOrders**(`leftOrders`: `Array<object>`, `rightOrders`: `Array<object>`, `leftSignatures`: string[], `rightSignatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3747](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3747)*

Match complementary orders that have a profitable spread.
Each order is filled at their respective price point, and
the matcher receives a profit denominated in the left maker asset.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrders` | `Array<object>` | Set of orders with the same maker / taker asset. |
`rightOrders` | `Array<object>` | Set of orders to match against `leftOrders` |
`leftSignatures` | string[] | Proof that left orders were created by the left     makers. |
`rightSignatures` | string[] | Proof that right orders were created by the right     makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

batchMatchedFillResults Amounts filled and profit generated.

___

###  batchMatchOrdersWithMaximalFill

▸ **batchMatchOrdersWithMaximalFill**(`leftOrders`: `Array<object>`, `rightOrders`: `Array<object>`, `leftSignatures`: string[], `rightSignatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3905](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3905)*

Match complementary orders that have a profitable spread.
Each order is maximally filled at their respective price point, and
the matcher receives a profit denominated in either the left maker asset,
right maker asset, or a combination of both.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrders` | `Array<object>` | Set of orders with the same maker / taker asset. |
`rightOrders` | `Array<object>` | Set of orders to match against `leftOrders` |
`leftSignatures` | string[] | Proof that left orders were created by the left     makers. |
`rightSignatures` | string[] | Proof that right orders were created by the right     makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

batchMatchedFillResults Amounts filled and profit generated.

___

###  cancelOrder

▸ **cancelOrder**(`order`: object): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4054](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4054)*

After calling, the order can not be filled anymore.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order struct containing order specifications.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  cancelOrdersUpTo

▸ **cancelOrdersUpTo**(`targetOrderEpoch`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4123](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4123)*

Cancels all orders created by makerAddress with a salt less than or equal to the targetOrderEpoch
and senderAddress equal to msg.sender (or null address if msg.sender == makerAddress).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`targetOrderEpoch` | `BigNumber` | Orders created with a salt less or equal to this     value will be cancelled.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  cancelled

▸ **cancelled**(`index_0`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4170](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4170)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  currentContextAddress

▸ **currentContextAddress**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4191](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4191)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  detachProtocolFeeCollector

▸ **detachProtocolFeeCollector**(): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4215](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4215)*

Sets the protocolFeeCollector contract address to 0.
Only callable by owner.

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  executeTransaction

▸ **executeTransaction**(`transaction`: object, `signature`: string): *`ContractTxFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4267](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4267)*

Executes an Exchange method call in the context of signer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transaction` | object | 0x transaction structure. |
`signature` | string | Proof that transaction has been signed by signer. |

**Returns:** *`ContractTxFunctionObj<string>`*

ABI encoded return data of the underlying Exchange function call.

___

###  fillOrKillOrder

▸ **fillOrKillOrder**(`order`: object, `takerAssetFillAmount`: `BigNumber`, `signature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4331](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4331)*

Fills the input order. Reverts if exact `takerAssetFillAmount` not filled.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order struct containing order specifications. |
`takerAssetFillAmount` | `BigNumber` | Desired amount of takerAsset to sell. |
`signature` | string | Proof that order has been created by maker. |

**Returns:** *`ContractTxFunctionObj<object>`*

fillResults Amounts filled and fees paid.

___

###  fillOrder

▸ **fillOrder**(`order`: object, `takerAssetFillAmount`: `BigNumber`, `signature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4428](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4428)*

Fills the input order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order struct containing order specifications. |
`takerAssetFillAmount` | `BigNumber` | Desired amount of takerAsset to sell. |
`signature` | string | Proof that order has been created by maker. |

**Returns:** *`ContractTxFunctionObj<object>`*

fillResults Amounts filled and fees paid by maker and taker.

___

###  filled

▸ **filled**(`index_0`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4518](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4518)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3213](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3213)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3205](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3205)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getAssetProxy

▸ **getAssetProxy**(`assetProxyId`: string): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4544](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4544)*

Gets an asset proxy.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetProxyId` | string | Id of the asset proxy. |

**Returns:** *`ContractFunctionObj<string>`*

assetProxy The asset proxy address registered to assetProxyId. Returns 0x0 if no proxy is registered.

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3198](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3198)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [ExchangeEvents](#enumeration-exchangeevents), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5991](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5991)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[ExchangeEventArgs](#exchangeeventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [ExchangeEvents](#enumeration-exchangeevents) | The Exchange contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getOrderInfo

▸ **getOrderInfo**(`order`: object): *`ContractFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4570](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4570)*

Gets information about an order: status, hash, and amount filled.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order to gather information on. |

**Returns:** *`ContractFunctionObj<object>`*

orderInfo Information about the order and its state.         See LibOrder.OrderInfo for a complete description.

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:3221](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L3221)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  isValidHashSignature

▸ **isValidHashSignature**(`hash`: string, `signerAddress`: string, `signature`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4621](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4621)*

Verifies that a hash has been signed by the given signer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`hash` | string | Any 32-byte hash. |
`signerAddress` | string | Address that should have signed the given hash. |
`signature` | string | Proof that the hash has been signed by signer. |

**Returns:** *`ContractFunctionObj<boolean>`*

isValid &#x60;true&#x60; if the signature is valid for the given hash and signer.

___

###  isValidOrderSignature

▸ **isValidOrderSignature**(`order`: object, `signature`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4650](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4650)*

Verifies that a signature for an order is valid.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | The order. |
`signature` | string | Proof that the order has been signed by signer. |

**Returns:** *`ContractFunctionObj<boolean>`*

isValid &#x60;true&#x60; if the signature is valid for the given order and signer.

___

###  isValidTransactionSignature

▸ **isValidTransactionSignature**(`transaction`: object, `signature`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4697](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4697)*

Verifies that a signature for a transaction is valid.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transaction` | object | The transaction. |
`signature` | string | Proof that the order has been signed by signer. |

**Returns:** *`ContractFunctionObj<boolean>`*

isValid &#x60;true&#x60; if the signature is valid for the given transaction and signer.

___

###  marketBuyOrdersFillOrKill

▸ **marketBuyOrdersFillOrKill**(`orders`: `Array<object>`, `makerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4736](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4736)*

Calls marketBuyOrdersNoThrow then reverts if < makerAssetFillAmount has been bought.
NOTE: This function does not enforce that the makerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`makerAssetFillAmount` | `BigNumber` | Minimum amount of makerAsset to buy. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

fillResults Amounts filled and fees paid by makers and taker.

___

###  marketBuyOrdersNoThrow

▸ **marketBuyOrdersNoThrow**(`orders`: `Array<object>`, `makerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4835](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4835)*

Executes multiple calls of fillOrder until total amount of makerAsset is bought by taker.
If any fill reverts, the error is caught and ignored.
NOTE: This function does not enforce that the makerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`makerAssetFillAmount` | `BigNumber` | Desired amount of makerAsset to buy. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

fillResults Amounts filled and fees paid by makers and taker.

___

###  marketSellOrdersFillOrKill

▸ **marketSellOrdersFillOrKill**(`orders`: `Array<object>`, `takerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:4933](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L4933)*

Calls marketSellOrdersNoThrow then reverts if < takerAssetFillAmount has been sold.
NOTE: This function does not enforce that the takerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmount` | `BigNumber` | Minimum amount of takerAsset to sell. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

fillResults Amounts filled and fees paid by makers and taker.

___

###  marketSellOrdersNoThrow

▸ **marketSellOrdersNoThrow**(`orders`: `Array<object>`, `takerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5032](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5032)*

Executes multiple calls of fillOrder until total amount of takerAsset is sold by taker.
If any fill reverts, the error is caught and ignored.
NOTE: This function does not enforce that the takerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmount` | `BigNumber` | Desired amount of takerAsset to sell. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

fillResults Amounts filled and fees paid by makers and taker.

___

###  matchOrders

▸ **matchOrders**(`leftOrder`: object, `rightOrder`: object, `leftSignature`: string, `rightSignature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5133](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5133)*

Match two complementary orders that have a profitable spread.
Each order is filled at their respective price point. However, the calculations are
carried out as though the orders are both being filled at the right order's price point.
The profit made by the left order goes to the taker (who matched the two orders).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrder` | object | First order to match. |
`rightOrder` | object | Second order to match. |
`leftSignature` | string | Proof that order was created by the left maker. |
`rightSignature` | string | Proof that order was created by the right maker. |

**Returns:** *`ContractTxFunctionObj<object>`*

matchedFillResults Amounts filled and fees paid by maker and taker of matched orders.

___

###  matchOrdersWithMaximalFill

▸ **matchOrdersWithMaximalFill**(`leftOrder`: object, `rightOrder`: object, `leftSignature`: string, `rightSignature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5288](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5288)*

Match two complementary orders that have a profitable spread.
Each order is maximally filled at their respective price point, and
the matcher receives a profit denominated in either the left maker asset,
right maker asset, or a combination of both.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrder` | object | First order to match. |
`rightOrder` | object | Second order to match. |
`leftSignature` | string | Proof that order was created by the left maker. |
`rightSignature` | string | Proof that order was created by the right maker. |

**Returns:** *`ContractTxFunctionObj<object>`*

matchedFillResults Amounts filled by maker and taker of matched orders.

___

###  orderEpoch

▸ **orderEpoch**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5432](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5432)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  owner

▸ **owner**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5454](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5454)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  preSign

▸ **preSign**(`hash`: string): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5479](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5479)*

Approves a hash on-chain.
After presigning a hash, the preSign signature type will become valid for that hash and signer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`hash` | string | Any 32-byte hash.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  preSigned

▸ **preSigned**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5526](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5526)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  protocolFeeCollector

▸ **protocolFeeCollector**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5548](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5548)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  protocolFeeMultiplier

▸ **protocolFeeMultiplier**(): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5568](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5568)*

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  registerAssetProxy

▸ **registerAssetProxy**(`assetProxy`: string): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5593](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5593)*

Registers an asset proxy to its asset proxy id.
Once an asset proxy is registered, it cannot be unregistered.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetProxy` | string | Address of new asset proxy to register.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setProtocolFeeCollectorAddress

▸ **setProtocolFeeCollectorAddress**(`updatedProtocolFeeCollector`: string): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5645](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5645)*

Allows the owner to update the protocolFeeCollector address.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`updatedProtocolFeeCollector` | string | The updated protocolFeeCollector contract     address.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setProtocolFeeMultiplier

▸ **setProtocolFeeMultiplier**(`updatedProtocolFeeMultiplier`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5696](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5696)*

Allows the owner to update the protocol fee multiplier.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`updatedProtocolFeeMultiplier` | `BigNumber` | The updated protocol fee multiplier.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setSignatureValidatorApproval

▸ **setSignatureValidatorApproval**(`validatorAddress`: string, `approval`: boolean): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5749](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5749)*

Approves/unnapproves a Validator contract to verify signatures on signer's behalf
using the `Validator` signature type.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`validatorAddress` | string | Address of Validator contract. |
`approval` | boolean | Approval or disapproval of  Validator contract.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  simulateDispatchTransferFromCalls

▸ **simulateDispatchTransferFromCalls**(`assetData`: string[], `fromAddresses`: string[], `toAddresses`: string[], `amounts`: `BigNumber`[]): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5809](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5809)*

This function may be used to simulate any amount of transfers As they would occur through the Exchange contract. Note that this function will always revert, even if all transfers are successful. However, it may be used with eth_call or with a try/catch pattern in order to simulate the results of the transfers.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |
`fromAddresses` | string[] | Array containing the `from` addresses that correspond     with each transfer. |
`toAddresses` | string[] | Array containing the `to` addresses that correspond with     each transfer. |
`amounts` | `BigNumber`[] | Array containing the amounts that correspond to each     transfer. |

**Returns:** *`ContractTxFunctionObj<void>`*

This function does not return a value. However, it will always revert with &#x60;Error(&quot;TRANSFERS_SUCCESSFUL&quot;)&#x60; if all of the transfers were successful.

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [ExchangeEvents](#enumeration-exchangeevents), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5946](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5946)*

Subscribe to an event type emitted by the Exchange contract.

**Type parameters:**

▪ **ArgsType**: *[ExchangeEventArgs](#exchangeeventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [ExchangeEvents](#enumeration-exchangeevents) | - | The Exchange contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  transactionsExecuted

▸ **transactionsExecuted**(`index_0`: string): *`ContractFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5864](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5864)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  transferOwnership

▸ **transferOwnership**(`newOwner`: string): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5889](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5889)*

Change the owner of this contract.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`newOwner` | string | New owner address.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5972](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5972)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:5979](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L5979)*

Cancels all existing subscriptions

**Returns:** *void*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:245](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L245)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `chainId`: `BigNumber`): *`Promise<ExchangeContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:196](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L196)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`chainId` | `BigNumber` |

**Returns:** *`Promise<ExchangeContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `chainId`: `BigNumber`): *`Promise<ExchangeContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:135](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L135)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`chainId` | `BigNumber` |

**Returns:** *`Promise<ExchangeContract>`*

___

### `Static` deployWithLibrariesFrom0xArtifactAsync

▸ **deployWithLibrariesFrom0xArtifactAsync**(`artifact`: `ContractArtifact`, `libraryArtifacts`: object, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `chainId`: `BigNumber`): *`Promise<ExchangeContract>`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:162](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L162)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` |
`libraryArtifacts` | object |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`chainId` | `BigNumber` |

**Returns:** *`Promise<ExchangeContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:44

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: WETH9Contract


##   Constructors



\+ **new WETH9Contract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[WETH9Contract](#class-weth9contract)*

*Overrides void*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:984](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L984)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  WETH9Contract.deployedBytecode |

**Returns:** *[WETH9Contract](#class-weth9contract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:34

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:30

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:31

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:33

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:32

___

### `Static` contractName

▪ **contractName**: *string* = "WETH9"

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:82](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L82)*

## Methods

###  allowance

▸ **allowance**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:552](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L552)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  approve

▸ **approve**(`guy`: string, `wad`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:574](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L574)*

**Parameters:**

Name | Type |
------ | ------ |
`guy` | string |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<boolean>`*

___

###  balanceOf

▸ **balanceOf**(`index_0`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:622](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L622)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  decimals

▸ **decimals**(): *`ContractFunctionObj<number>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:643](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L643)*

**Returns:** *`ContractFunctionObj<number>`*

___

###  deposit

▸ **deposit**(): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:663](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L663)*

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:537](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L537)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:529](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L529)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:522](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L522)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [WETH9Events](#enumeration-weth9events), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:968](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L968)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[WETH9EventArgs](#weth9eventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [WETH9Events](#enumeration-weth9events) | The WETH9 contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:545](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L545)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  name

▸ **name**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:709](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L709)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [WETH9Events](#enumeration-weth9events), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:923](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L923)*

Subscribe to an event type emitted by the WETH9 contract.

**Type parameters:**

▪ **ArgsType**: *[WETH9EventArgs](#weth9eventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [WETH9Events](#enumeration-weth9events) | - | The WETH9 contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  symbol

▸ **symbol**(): *`ContractFunctionObj<string>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:729](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L729)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  totalSupply

▸ **totalSupply**(): *`ContractFunctionObj<BigNumber>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:749](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L749)*

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  transfer

▸ **transfer**(`dst`: string, `wad`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:769](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L769)*

**Parameters:**

Name | Type |
------ | ------ |
`dst` | string |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<boolean>`*

___

###  transferFrom

▸ **transferFrom**(`src`: string, `dst`: string, `wad`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:817](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L817)*

**Parameters:**

Name | Type |
------ | ------ |
`src` | string |
`dst` | string |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<boolean>`*

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:949](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L949)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:956](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L956)*

Cancels all existing subscriptions

**Returns:** *void*

___

###  withdraw

▸ **withdraw**(`wad`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:866](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L866)*

**Parameters:**

Name | Type |
------ | ------ |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<void>`*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:188](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L188)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<WETH9Contract>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:144](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L144)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<WETH9Contract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<WETH9Contract>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:85](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L85)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<WETH9Contract>`*

___

### `Static` deployWithLibrariesFrom0xArtifactAsync

▸ **deployWithLibrariesFrom0xArtifactAsync**(`artifact`: `ContractArtifact`, `libraryArtifacts`: object, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<WETH9Contract>`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:111](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L111)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` |
`libraryArtifacts` | object |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<WETH9Contract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:44

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: MetamaskSubprovider

This class implements the [web3-provider-engine](https://github.com/MetaMask/provider-engine)
subprovider interface and the provider sendAsync interface.
It handles inconsistencies with Metamask implementations of various JSON RPC methods.
It forwards JSON RPC requests involving the domain of a signer (getAccounts,
sendTransaction, signMessage etc...) to the provider instance supplied at instantiation. All other requests
are passed onwards for subsequent subproviders to handle.


##   Constructors



\+ **new MetamaskSubprovider**(`supportedProvider`: [SupportedProvider](#supportedprovider)): *[MetamaskSubprovider](#class-metamasksubprovider)*

*Defined in [subproviders/src/subproviders/metamask_subprovider.ts:19](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/metamask_subprovider.ts#L19)*

Instantiates a new MetamaskSubprovider

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider that should handle  all user account related requests  |

**Returns:** *[MetamaskSubprovider](#class-metamasksubprovider)*

## Methods

###  emitPayloadAsync

▸ **emitPayloadAsync**(`payload`: `Partial<JSONRPCRequestPayloadWithMethod>`): *`Promise<JSONRPCResponsePayload>`*



*Defined in [subproviders/src/subproviders/subprovider.ts:55](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/subprovider.ts#L55)*

Emits a JSON RPC payload that will then be handled by the ProviderEngine instance
this subprovider is a part of. The payload will cascade down the subprovider middleware
stack until finding the responsible entity for handling the request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `Partial<JSONRPCRequestPayloadWithMethod>` | JSON RPC payload |

**Returns:** *`Promise<JSONRPCResponsePayload>`*

JSON RPC response payload

___

###  handleRequest

▸ **handleRequest**(`payload`: `JSONRPCRequestPayload`, `next`: [Callback](#callback), `end`: [ErrorCallback](#errorcallback)): *`Promise<void>`*

*Overrides void*

*Defined in [subproviders/src/subproviders/metamask_subprovider.ts:39](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/metamask_subprovider.ts#L39)*

This method conforms to the web3-provider-engine interface.
It is called internally by the ProviderEngine when it is this subproviders
turn to handle a JSON RPC request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `JSONRPCRequestPayload` | JSON RPC payload |
`next` | [Callback](#callback) | Callback to call if this subprovider decides not to handle the request |
`end` | [ErrorCallback](#errorcallback) | Callback to call if subprovider handled the request and wants to pass back the request.  |

**Returns:** *`Promise<void>`*

___

###  sendAsync

▸ **sendAsync**(`payload`: `JSONRPCRequestPayload`, `callback`: [ErrorCallback](#errorcallback)): *void*

*Defined in [subproviders/src/subproviders/metamask_subprovider.ts:117](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/metamask_subprovider.ts#L117)*

This method conforms to the provider sendAsync interface.
Allowing the MetamaskSubprovider to be used as a generic provider (outside of Web3ProviderEngine) with the
addition of wrapping the inconsistent Metamask behaviour

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `JSONRPCRequestPayload` | JSON RPC payload |
`callback` | [ErrorCallback](#errorcallback) | - |

**Returns:** *void*

The contents nested under the result key of the response body

___

###  setEngine

▸ **setEngine**(`engine`: `Web3ProviderEngine`): *void*



*Defined in [subproviders/src/subproviders/subprovider.ts:68](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/subprovider.ts#L68)*

Set's the subprovider's engine to the ProviderEngine it is added to.
This is only called within the ProviderEngine source code, do not call
directly.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`engine` | `Web3ProviderEngine` | The ProviderEngine this subprovider is added to  |

**Returns:** *void*

<hr />

# Class: RPCSubprovider

This class implements the [web3-provider-engine](https://github.com/MetaMask/provider-engine) subprovider interface.
It forwards on JSON RPC requests to the supplied `rpcUrl` endpoint


##   Constructors



\+ **new RPCSubprovider**(`rpcUrl`: string, `requestTimeoutMs`: number): *[RPCSubprovider](#class-rpcsubprovider)*

*Defined in [subproviders/src/subproviders/rpc_subprovider.ts:17](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/rpc_subprovider.ts#L17)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`rpcUrl` | string | - | URL to the backing Ethereum node to which JSON RPC requests should be sent |
`requestTimeoutMs` | number | 20000 | Amount of miliseconds to wait before timing out the JSON RPC request  |

**Returns:** *[RPCSubprovider](#class-rpcsubprovider)*

## Methods

###  emitPayloadAsync

▸ **emitPayloadAsync**(`payload`: `Partial<JSONRPCRequestPayloadWithMethod>`): *`Promise<JSONRPCResponsePayload>`*



*Defined in [subproviders/src/subproviders/subprovider.ts:55](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/subprovider.ts#L55)*

Emits a JSON RPC payload that will then be handled by the ProviderEngine instance
this subprovider is a part of. The payload will cascade down the subprovider middleware
stack until finding the responsible entity for handling the request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `Partial<JSONRPCRequestPayloadWithMethod>` | JSON RPC payload |

**Returns:** *`Promise<JSONRPCResponsePayload>`*

JSON RPC response payload

___

###  handleRequest

▸ **handleRequest**(`payload`: `JSONRPCRequestPayload`, `_next`: [Callback](#callback), `end`: [ErrorCallback](#errorcallback)): *`Promise<void>`*

*Overrides void*

*Defined in [subproviders/src/subproviders/rpc_subprovider.ts:38](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/rpc_subprovider.ts#L38)*

This method conforms to the web3-provider-engine interface.
It is called internally by the ProviderEngine when it is this subproviders
turn to handle a JSON RPC request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `JSONRPCRequestPayload` | JSON RPC payload |
`_next` | [Callback](#callback) | Callback to call if this subprovider decides not to handle the request |
`end` | [ErrorCallback](#errorcallback) | Callback to call if subprovider handled the request and wants to pass back the request.  |

**Returns:** *`Promise<void>`*

___

###  setEngine

▸ **setEngine**(`engine`: `Web3ProviderEngine`): *void*



*Defined in [subproviders/src/subproviders/subprovider.ts:68](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/subproviders/subprovider.ts#L68)*

Set's the subprovider's engine to the ProviderEngine it is added to.
This is only called within the ProviderEngine source code, do not call
directly.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`engine` | `Web3ProviderEngine` | The ProviderEngine this subprovider is added to  |

**Returns:** *void*

<hr />

# Enumeration: SubscriptionErrors


##  Enumeration members

###  SubscriptionAlreadyPresent

• **SubscriptionAlreadyPresent**: = "SUBSCRIPTION_ALREADY_PRESENT"

*Defined in [base-contract/src/types.ts:21](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L21)*

___

###  SubscriptionNotFound

• **SubscriptionNotFound**: = "SUBSCRIPTION_NOT_FOUND"

*Defined in [base-contract/src/types.ts:20](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L20)*

<hr />

# Enumeration: ChainId


##  Enumeration members

###  Ganache

• **Ganache**: = 1337

*Defined in [contract-addresses/src/index.ts:39](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L39)*

___

###  Kovan

• **Kovan**: = 42

*Defined in [contract-addresses/src/index.ts:38](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L38)*

___

###  Mainnet

• **Mainnet**: = 1

*Defined in [contract-addresses/src/index.ts:35](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L35)*

___

###  Rinkeby

• **Rinkeby**: = 4

*Defined in [contract-addresses/src/index.ts:37](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L37)*

___

###  Ropsten

• **Ropsten**: = 3

*Defined in [contract-addresses/src/index.ts:36](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L36)*

<hr />

# Enumeration: ERC20TokenEvents


##  Enumeration members

###  Approval

• **Approval**: = "Approval"

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:41](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L41)*

___

###  Transfer

• **Transfer**: = "Transfer"

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:42](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L42)*

<hr />

# Enumeration: ERC721TokenEvents


##  Enumeration members

###  Approval

• **Approval**: = "Approval"

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:44](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L44)*

___

###  ApprovalForAll

• **ApprovalForAll**: = "ApprovalForAll"

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:45](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L45)*

___

###  Transfer

• **Transfer**: = "Transfer"

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:46](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L46)*

<hr />

# Enumeration: ExchangeEvents


##  Enumeration members

###  AssetProxyRegistered

• **AssetProxyRegistered**: = "AssetProxyRegistered"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:50](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L50)*

___

###  Cancel

• **Cancel**: = "Cancel"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:51](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L51)*

___

###  CancelUpTo

• **CancelUpTo**: = "CancelUpTo"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:52](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L52)*

___

###  Fill

• **Fill**: = "Fill"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:53](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L53)*

___

###  OwnershipTransferred

• **OwnershipTransferred**: = "OwnershipTransferred"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:54](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L54)*

___

###  ProtocolFeeCollectorAddress

• **ProtocolFeeCollectorAddress**: = "ProtocolFeeCollectorAddress"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:55](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L55)*

___

###  ProtocolFeeMultiplier

• **ProtocolFeeMultiplier**: = "ProtocolFeeMultiplier"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:56](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L56)*

___

###  SignatureValidatorApproval

• **SignatureValidatorApproval**: = "SignatureValidatorApproval"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:57](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L57)*

___

###  TransactionExecution

• **TransactionExecution**: = "TransactionExecution"

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:58](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L58)*

<hr />

# Enumeration: WETH9Events


##  Enumeration members

###  Approval

• **Approval**: = "Approval"

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:45](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L45)*

___

###  Deposit

• **Deposit**: = "Deposit"

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:46](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L46)*

___

###  Transfer

• **Transfer**: = "Transfer"

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:47](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L47)*

___

###  Withdrawal

• **Withdrawal**: = "Withdrawal"

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:48](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L48)*

<hr />



# Enumeration: BlockParamLiteral


##  Enumeration members

###  Earliest

• **Earliest**: = "earliest"

*Defined in [ethereum-types/src/index.ts:479](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L479)*

___

###  Latest

• **Latest**: = "latest"

*Defined in [ethereum-types/src/index.ts:480](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L480)*

___

###  Pending

• **Pending**: = "pending"

*Defined in [ethereum-types/src/index.ts:481](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L481)*

<hr />

























# Enumeration: SignatureType


##  Enumeration members

###  EIP1271Wallet

• **EIP1271Wallet**:

*Defined in [types/src/index.ts:158](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L158)*

___

###  EIP712

• **EIP712**:

*Defined in [types/src/index.ts:153](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L153)*

___

###  EthSign

• **EthSign**:

*Defined in [types/src/index.ts:154](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L154)*

___

###  Illegal

• **Illegal**:

*Defined in [types/src/index.ts:151](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L151)*

___

###  Invalid

• **Invalid**:

*Defined in [types/src/index.ts:152](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L152)*

___

###  NSignatureTypes

• **NSignatureTypes**:

*Defined in [types/src/index.ts:159](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L159)*

___

###  PreSigned

• **PreSigned**:

*Defined in [types/src/index.ts:157](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L157)*

___

###  Validator

• **Validator**:

*Defined in [types/src/index.ts:156](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L156)*

___

###  Wallet

• **Wallet**:

*Defined in [types/src/index.ts:155](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L155)*

<hr />









# Interface: AwaitTransactionSuccessOpts

Used with `awaitTransactionSuccessAsync`
* pollingIntervalMs: Determine polling intervals in milliseconds
* timeoutMs: Determines timeout in milliseconds


##   Properties

### `Optional` pollingIntervalMs

• **pollingIntervalMs**? : *undefined | number*

*Defined in [base-contract/src/types.ts:39](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L39)*

___

### `Optional` shouldValidate

• **shouldValidate**? : *undefined | false | true*

*Inherited from [SendTransactionOpts](#interface-sendtransactionopts).[shouldValidate](#optional-shouldvalidate)*

*Defined in [base-contract/src/types.ts:30](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L30)*

___

### `Optional` timeoutMs

• **timeoutMs**? : *undefined | number*

*Defined in [base-contract/src/types.ts:40](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L40)*

<hr />

# Interface: ContractEvent <**ContractEventArgs**>

## Type parameters

▪ **ContractEventArgs**


##   Properties

###  address

• **address**: *string*

*Defined in [base-contract/src/types.ts:13](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L13)*

___

###  args

• **args**: *`ContractEventArgs`*

*Defined in [base-contract/src/types.ts:16](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L16)*

___

###  blockHash

• **blockHash**: *string*

*Defined in [base-contract/src/types.ts:11](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L11)*

___

###  blockNumber

• **blockNumber**: *number*

*Defined in [base-contract/src/types.ts:12](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L12)*

___

###  event

• **event**: *string*

*Defined in [base-contract/src/types.ts:15](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L15)*

___

###  logIndex

• **logIndex**: *number*

*Defined in [base-contract/src/types.ts:8](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L8)*

___

###  transactionHash

• **transactionHash**: *string*

*Defined in [base-contract/src/types.ts:10](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L10)*

___

###  transactionIndex

• **transactionIndex**: *number*

*Defined in [base-contract/src/types.ts:9](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L9)*

___

###  type

• **type**: *string*

*Defined in [base-contract/src/types.ts:14](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L14)*

<hr />

# Interface: ContractFunctionObj <**T**>

## Type parameters

▪ **T**


##   Methods

###  callAsync

▸ **callAsync**(`callData?`: `Partial<CallData>`, `defaultBlock?`: [BlockParam](#blockparam)): *`Promise<T>`*

*Defined in [base-contract/src/types.ts:44](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L44)*

**Parameters:**

Name | Type |
------ | ------ |
`callData?` | `Partial<CallData>` |
`defaultBlock?` | [BlockParam](#blockparam) |

**Returns:** *`Promise<T>`*

___

###  getABIEncodedTransactionData

▸ **getABIEncodedTransactionData**(): *string*

*Defined in [base-contract/src/types.ts:45](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L45)*

**Returns:** *string*

<hr />

# Interface: ContractTxFunctionObj <**T**>

## Type parameters

▪ **T**


##   Methods

###  awaitTransactionSuccessAsync

▸ **awaitTransactionSuccessAsync**(`txData?`: `Partial<TxData>`, `opts?`: [AwaitTransactionSuccessOpts](#class-awaittransactionsuccessopts)): *`PromiseWithTransactionHash<TransactionReceiptWithDecodedLogs>`*

*Defined in [base-contract/src/types.ts:50](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L50)*

**Parameters:**

Name | Type |
------ | ------ |
`txData?` | `Partial<TxData>` |
`opts?` | [AwaitTransactionSuccessOpts](#class-awaittransactionsuccessopts) |

**Returns:** *`PromiseWithTransactionHash<TransactionReceiptWithDecodedLogs>`*

___

###  callAsync

▸ **callAsync**(`callData?`: `Partial<CallData>`, `defaultBlock?`: [BlockParam](#blockparam)): *`Promise<T>`*

*Inherited from [ContractFunctionObj](#interface-contractfunctionobj).[callAsync](#callasync)*

*Defined in [base-contract/src/types.ts:44](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L44)*

**Parameters:**

Name | Type |
------ | ------ |
`callData?` | `Partial<CallData>` |
`defaultBlock?` | [BlockParam](#blockparam) |

**Returns:** *`Promise<T>`*

___

###  estimateGasAsync

▸ **estimateGasAsync**(`txData?`: `Partial<TxData>`): *`Promise<number>`*

*Defined in [base-contract/src/types.ts:54](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L54)*

**Parameters:**

Name | Type |
------ | ------ |
`txData?` | `Partial<TxData>` |

**Returns:** *`Promise<number>`*

___

###  getABIEncodedTransactionData

▸ **getABIEncodedTransactionData**(): *string*

*Inherited from [ContractFunctionObj](#interface-contractfunctionobj).[getABIEncodedTransactionData](#getabiencodedtransactiondata)*

*Defined in [base-contract/src/types.ts:45](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L45)*

**Returns:** *string*

___

###  sendTransactionAsync

▸ **sendTransactionAsync**(`txData?`: `Partial<TxData>`, `opts?`: [SendTransactionOpts](#class-sendtransactionopts)): *`Promise<string>`*

*Defined in [base-contract/src/types.ts:49](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L49)*

**Parameters:**

Name | Type |
------ | ------ |
`txData?` | `Partial<TxData>` |
`opts?` | [SendTransactionOpts](#class-sendtransactionopts) |

**Returns:** *`Promise<string>`*

<hr />

# Interface: SendTransactionOpts

Used with `sendTransactionAsync`
* shouldValidate: Flag indicating whether the library should make attempts to validate a transaction before
broadcasting it. For example, order has a valid signature, maker has sufficient funds, etc. Default=true.


##   Properties

### `Optional` shouldValidate

• **shouldValidate**? : *undefined | false | true*

*Defined in [base-contract/src/types.ts:30](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/base-contract/src/types.ts#L30)*

<hr />

# Interface: ContractAddresses


##   Properties

###  assetProxyOwner

• **assetProxyOwner**: *string*

*Defined in [contract-addresses/src/index.ts:12](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L12)*

___

###  chaiBridge

• **chaiBridge**: *string*

*Defined in [contract-addresses/src/index.ts:29](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L29)*

___

###  coordinator

• **coordinator**: *string*

*Defined in [contract-addresses/src/index.ts:16](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L16)*

___

###  coordinatorRegistry

• **coordinatorRegistry**: *string*

*Defined in [contract-addresses/src/index.ts:15](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L15)*

___

###  curveBridge

• **curveBridge**: *string*

*Defined in [contract-addresses/src/index.ts:31](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L31)*

___

###  devUtils

• **devUtils**: *string*

*Defined in [contract-addresses/src/index.ts:20](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L20)*

___

###  dydxBridge

• **dydxBridge**: *string*

*Defined in [contract-addresses/src/index.ts:30](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L30)*

___

###  erc1155Proxy

• **erc1155Proxy**: *string*

*Defined in [contract-addresses/src/index.ts:19](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L19)*

___

###  erc20BridgeProxy

• **erc20BridgeProxy**: *string*

*Defined in [contract-addresses/src/index.ts:24](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L24)*

___

###  erc20BridgeSampler

• **erc20BridgeSampler**: *string*

*Defined in [contract-addresses/src/index.ts:25](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L25)*

___

###  erc20Proxy

• **erc20Proxy**: *string*

*Defined in [contract-addresses/src/index.ts:6](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L6)*

___

###  erc721Proxy

• **erc721Proxy**: *string*

*Defined in [contract-addresses/src/index.ts:7](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L7)*

___

###  eth2DaiBridge

• **eth2DaiBridge**: *string*

*Defined in [contract-addresses/src/index.ts:27](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L27)*

___

###  etherToken

• **etherToken**: *string*

*Defined in [contract-addresses/src/index.ts:9](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L9)*

___

###  exchange

• **exchange**: *string*

*Defined in [contract-addresses/src/index.ts:11](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L11)*

___

###  exchangeV2

• **exchangeV2**: *string*

*Defined in [contract-addresses/src/index.ts:10](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L10)*

___

###  forwarder

• **forwarder**: *string*

*Defined in [contract-addresses/src/index.ts:14](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L14)*

___

###  kyberBridge

• **kyberBridge**: *string*

*Defined in [contract-addresses/src/index.ts:28](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L28)*

___

###  multiAssetProxy

• **multiAssetProxy**: *string*

*Defined in [contract-addresses/src/index.ts:17](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L17)*

___

###  staking

• **staking**: *string*

*Defined in [contract-addresses/src/index.ts:22](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L22)*

___

###  stakingProxy

• **stakingProxy**: *string*

*Defined in [contract-addresses/src/index.ts:23](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L23)*

___

###  staticCallProxy

• **staticCallProxy**: *string*

*Defined in [contract-addresses/src/index.ts:18](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L18)*

___

###  uniswapBridge

• **uniswapBridge**: *string*

*Defined in [contract-addresses/src/index.ts:26](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L26)*

___

###  zeroExGovernor

• **zeroExGovernor**: *string*

*Defined in [contract-addresses/src/index.ts:13](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L13)*

___

###  zrxToken

• **zrxToken**: *string*

*Defined in [contract-addresses/src/index.ts:8](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L8)*

___

###  zrxVault

• **zrxVault**: *string*

*Defined in [contract-addresses/src/index.ts:21](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L21)*

<hr />

# Interface: ERC20TokenApprovalEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_spender](#_spender)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:46](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L46)*

___

###  _spender

• **_spender**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:47](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L47)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:48](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L48)*

<hr />

# Interface: ERC20TokenTransferEventArgs


##   Index

### Properties

* [_from](#_from)
* [_to](#_to)
* [_value](#_value)

## Properties

###  _from

• **_from**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:52](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L52)*

___

###  _to

• **_to**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:53](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L53)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:54](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L54)*

<hr />

# Interface: ERC721TokenApprovalEventArgs


##   Index

### Properties

* [_approved](#_approved)
* [_owner](#_owner)
* [_tokenId](#_tokenid)

## Properties

###  _approved

• **_approved**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:51](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L51)*

___

###  _owner

• **_owner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:50](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L50)*

___

###  _tokenId

• **_tokenId**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:52](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L52)*

<hr />

# Interface: ERC721TokenApprovalForAllEventArgs


##   Index

### Properties

* [_approved](#_approved)
* [_operator](#_operator)
* [_owner](#_owner)

## Properties

###  _approved

• **_approved**: *boolean*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:58](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L58)*

___

###  _operator

• **_operator**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:57](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L57)*

___

###  _owner

• **_owner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:56](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L56)*

<hr />

# Interface: ERC721TokenTransferEventArgs


##   Index

### Properties

* [_from](#_from)
* [_to](#_to)
* [_tokenId](#_tokenid)

## Properties

###  _from

• **_from**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:62](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L62)*

___

###  _to

• **_to**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:63](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L63)*

___

###  _tokenId

• **_tokenId**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:64](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L64)*

<hr />

# Interface: ExchangeAssetProxyRegisteredEventArgs


##   Index

### Properties

* [assetProxy](#assetproxy)
* [id](#id)

## Properties

###  assetProxy

• **assetProxy**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:63](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L63)*

___

###  id

• **id**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:62](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L62)*

<hr />

# Interface: ExchangeCancelEventArgs


##   Index

### Properties

* [feeRecipientAddress](#feerecipientaddress)
* [makerAddress](#makeraddress)
* [makerAssetData](#makerassetdata)
* [orderHash](#orderhash)
* [senderAddress](#senderaddress)
* [takerAssetData](#takerassetdata)

## Properties

###  feeRecipientAddress

• **feeRecipientAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:68](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L68)*

___

###  makerAddress

• **makerAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:67](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L67)*

___

###  makerAssetData

• **makerAssetData**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:69](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L69)*

___

###  orderHash

• **orderHash**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:72](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L72)*

___

###  senderAddress

• **senderAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:71](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L71)*

___

###  takerAssetData

• **takerAssetData**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:70](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L70)*

<hr />

# Interface: ExchangeCancelUpToEventArgs


##   Index

### Properties

* [makerAddress](#makeraddress)
* [orderEpoch](#orderepoch)
* [orderSenderAddress](#ordersenderaddress)

## Properties

###  makerAddress

• **makerAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:76](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L76)*

___

###  orderEpoch

• **orderEpoch**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:78](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L78)*

___

###  orderSenderAddress

• **orderSenderAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:77](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L77)*

<hr />

# Interface: ExchangeFillEventArgs


##   Index

### Properties

* [feeRecipientAddress](#feerecipientaddress)
* [makerAddress](#makeraddress)
* [makerAssetData](#makerassetdata)
* [makerAssetFilledAmount](#makerassetfilledamount)
* [makerFeeAssetData](#makerfeeassetdata)
* [makerFeePaid](#makerfeepaid)
* [orderHash](#orderhash)
* [protocolFeePaid](#protocolfeepaid)
* [senderAddress](#senderaddress)
* [takerAddress](#takeraddress)
* [takerAssetData](#takerassetdata)
* [takerAssetFilledAmount](#takerassetfilledamount)
* [takerFeeAssetData](#takerfeeassetdata)
* [takerFeePaid](#takerfeepaid)

## Properties

###  feeRecipientAddress

• **feeRecipientAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:83](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L83)*

___

###  makerAddress

• **makerAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:82](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L82)*

___

###  makerAssetData

• **makerAssetData**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:84](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L84)*

___

###  makerAssetFilledAmount

• **makerAssetFilledAmount**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:91](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L91)*

___

###  makerFeeAssetData

• **makerFeeAssetData**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:86](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L86)*

___

###  makerFeePaid

• **makerFeePaid**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:93](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L93)*

___

###  orderHash

• **orderHash**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:88](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L88)*

___

###  protocolFeePaid

• **protocolFeePaid**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:95](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L95)*

___

###  senderAddress

• **senderAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:90](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L90)*

___

###  takerAddress

• **takerAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:89](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L89)*

___

###  takerAssetData

• **takerAssetData**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:85](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L85)*

___

###  takerAssetFilledAmount

• **takerAssetFilledAmount**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:92](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L92)*

___

###  takerFeeAssetData

• **takerFeeAssetData**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:87](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L87)*

___

###  takerFeePaid

• **takerFeePaid**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:94](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L94)*

<hr />

# Interface: ExchangeOwnershipTransferredEventArgs


##   Index

### Properties

* [newOwner](#newowner)
* [previousOwner](#previousowner)

## Properties

###  newOwner

• **newOwner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:100](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L100)*

___

###  previousOwner

• **previousOwner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:99](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L99)*

<hr />

# Interface: ExchangeProtocolFeeCollectorAddressEventArgs


##   Index

### Properties

* [oldProtocolFeeCollector](#oldprotocolfeecollector)
* [updatedProtocolFeeCollector](#updatedprotocolfeecollector)

## Properties

###  oldProtocolFeeCollector

• **oldProtocolFeeCollector**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:104](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L104)*

___

###  updatedProtocolFeeCollector

• **updatedProtocolFeeCollector**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:105](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L105)*

<hr />

# Interface: ExchangeProtocolFeeMultiplierEventArgs


##   Index

### Properties

* [oldProtocolFeeMultiplier](#oldprotocolfeemultiplier)
* [updatedProtocolFeeMultiplier](#updatedprotocolfeemultiplier)

## Properties

###  oldProtocolFeeMultiplier

• **oldProtocolFeeMultiplier**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:109](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L109)*

___

###  updatedProtocolFeeMultiplier

• **updatedProtocolFeeMultiplier**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:110](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L110)*

<hr />

# Interface: ExchangeSignatureValidatorApprovalEventArgs


##   Index

### Properties

* [isApproved](#isapproved)
* [signerAddress](#signeraddress)
* [validatorAddress](#validatoraddress)

## Properties

###  isApproved

• **isApproved**: *boolean*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:116](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L116)*

___

###  signerAddress

• **signerAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:114](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L114)*

___

###  validatorAddress

• **validatorAddress**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:115](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L115)*

<hr />

# Interface: ExchangeTransactionExecutionEventArgs


##   Index

### Properties

* [transactionHash](#transactionhash)

## Properties

###  transactionHash

• **transactionHash**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:120](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L120)*

<hr />

# Interface: WETH9ApprovalEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_spender](#_spender)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:52](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L52)*

___

###  _spender

• **_spender**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:53](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L53)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:54](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L54)*

<hr />

# Interface: WETH9DepositEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:58](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L58)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:59](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L59)*

<hr />

# Interface: WETH9TransferEventArgs


##   Index

### Properties

* [_from](#_from)
* [_to](#_to)
* [_value](#_value)

## Properties

###  _from

• **_from**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:63](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L63)*

___

###  _to

• **_to**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:64](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L64)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:65](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L65)*

<hr />

# Interface: WETH9WithdrawalEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:69](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L69)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:70](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L70)*

<hr />



# Interface: BlockRange


##   Properties

###  fromBlock

• **fromBlock**: *[BlockParam](#blockparam)*

*Defined in [ethereum-types/src/index.ts:750](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L750)*

___

###  toBlock

• **toBlock**: *[BlockParam](#blockparam)*

*Defined in [ethereum-types/src/index.ts:751](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L751)*

<hr />





# Interface: CallData


##   Properties

### `Optional` data

• **data**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[data](#optional-data)*

*Defined in [ethereum-types/src/index.ts:394](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L394)*

___

### `Optional` from

• **from**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:403](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L403)*

___

### `Optional` gas

• **gas**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gas](#optional-gas)*

*Defined in [ethereum-types/src/index.ts:392](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L392)*

___

### `Optional` gasPrice

• **gasPrice**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gasPrice](#optional-gasprice)*

*Defined in [ethereum-types/src/index.ts:393](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L393)*

___

### `Optional` nonce

• **nonce**? : *undefined | number*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[nonce](#optional-nonce)*

*Defined in [ethereum-types/src/index.ts:395](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L395)*

___

### `Optional` to

• **to**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[to](#optional-to)*

*Defined in [ethereum-types/src/index.ts:390](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L390)*

___

### `Optional` value

• **value**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[value](#optional-value)*

*Defined in [ethereum-types/src/index.ts:391](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L391)*

<hr />





# Interface: CompilerOpts


##   Properties

###  name

• **name**: *"solc"*

*Defined in [ethereum-types/src/index.ts:663](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L663)*

___

###  settings

• **settings**: *[CompilerSettings](#class-compilersettings)*

*Defined in [ethereum-types/src/index.ts:665](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L665)*

___

###  version

• **version**: *string*

*Defined in [ethereum-types/src/index.ts:664](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L664)*

<hr />

# Interface: CompilerSettings


##   Properties

### `Optional` evmVersion

• **evmVersion**? : *"homestead" | "tangerineWhistle" | "spuriousDragon" | "byzantium" | "constantinople"*

*Defined in [ethereum-types/src/index.ts:697](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L697)*

___

### `Optional` libraries

• **libraries**? : *undefined | object*

*Defined in [ethereum-types/src/index.ts:699](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L699)*

___

### `Optional` metadata

• **metadata**? : *[CompilerSettingsMetadata](#class-compilersettingsmetadata)*

*Defined in [ethereum-types/src/index.ts:698](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L698)*

___

### `Optional` optimizer

• **optimizer**? : *[OptimizerSettings](#class-optimizersettings)*

*Defined in [ethereum-types/src/index.ts:696](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L696)*

___

###  outputSelection

• **outputSelection**: *object*

*Defined in [ethereum-types/src/index.ts:704](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L704)*

#### Type declaration:

● \[▪ **fileName**: *string*\]: object

● \[▪ **contractName**: *string*\]: [OutputField](#outputfield)[]

___

### `Optional` remappings

• **remappings**? : *string[]*

*Defined in [ethereum-types/src/index.ts:695](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L695)*

<hr />

# Interface: CompilerSettingsMetadata


##   Properties

###  useLiteralContent

• **useLiteralContent**: *true*

*Defined in [ethereum-types/src/index.ts:712](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L712)*

<hr />

# Interface: ConstructorAbi


##   Properties

###  inputs

• **inputs**: *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:103](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L103)*

___

###  payable

• **payable**: *boolean*

*Defined in [ethereum-types/src/index.ts:104](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L104)*

___

###  stateMutability

• **stateMutability**: *[ConstructorStateMutability](#constructorstatemutability)*

*Defined in [ethereum-types/src/index.ts:105](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L105)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:102](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L102)*

<hr />

# Interface: ContractArtifact

This type defines the schema of the artifact.json file generated by Sol-compiler
schemaVersion: The version of the artifact schema
contractName: The contract name it represents
chains: Chain specific information by chain (address, id, constructor args, etc...)
compilerOutput: The Solidity compiler output generated from the specified compiler input
description (http://solidity.readthedocs.io/en/v0.4.24/using-the-compiler.html#compiler-input-and-output-json-description)
compiler: The compiler settings used
sourceCodes: The source code of the contract and all it's dependencies
sources: A mapping from source filePath to sourceMap id
sourceTreeHashHex: A unique hash generated from the contract source and that of it's dependencies.
If any of the sources change, the hash would change notifying us that a re-compilation is necessary


##   Properties

###  chains

• **chains**: *[ContractChains](#class-contractchains)*

*Defined in [ethereum-types/src/index.ts:684](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L684)*

___

###  compiler

• **compiler**: *[CompilerOpts](#class-compileropts)*

*Inherited from [ContractVersionData](#interface-contractversiondata).[compiler](#compiler)*

*Defined in [ethereum-types/src/index.ts:649](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L649)*

___

###  compilerOutput

• **compilerOutput**: *[StandardContractOutput](#class-standardcontractoutput)*

*Inherited from [ContractVersionData](#interface-contractversiondata).[compilerOutput](#compileroutput)*

*Defined in [ethereum-types/src/index.ts:659](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L659)*

___

###  contractName

• **contractName**: *string*

*Defined in [ethereum-types/src/index.ts:683](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L683)*

___

###  schemaVersion

• **schemaVersion**: *string*

*Defined in [ethereum-types/src/index.ts:682](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L682)*

___

###  sourceCodes

• **sourceCodes**: *object*

*Inherited from [ContractVersionData](#interface-contractversiondata).[sourceCodes](#sourcecodes)*

*Defined in [ethereum-types/src/index.ts:655](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L655)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: string

___

###  sourceTreeHashHex

• **sourceTreeHashHex**: *string*

*Inherited from [ContractVersionData](#interface-contractversiondata).[sourceTreeHashHex](#sourcetreehashhex)*

*Defined in [ethereum-types/src/index.ts:658](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L658)*

___

###  sources

• **sources**: *object*

*Inherited from [ContractVersionData](#interface-contractversiondata).[sources](#sources)*

*Defined in [ethereum-types/src/index.ts:650](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L650)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: object

<hr />

# Interface: ContractChainData


##   Properties

###  address

• **address**: *string*

*Defined in [ethereum-types/src/index.ts:555](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L555)*

___

Args

• **constructorArgs**: *string*

*Defined in [ethereum-types/src/index.ts:559](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L559)*

___

###  links

• **links**: *object*

*Defined in [ethereum-types/src/index.ts:556](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L556)*

#### Type declaration:

● \[▪ **linkName**: *string*\]: string

<hr />

# Interface: ContractChains


##  Hierarchy

* **ContractVersionData**

  * [ContractArtifact](#class-contractartifact)


##  Properties

###  compiler

• **compiler**: *[CompilerOpts](#class-compileropts)*

*Defined in [ethereum-types/src/index.ts:649](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L649)*

___

###  compilerOutput

• **compilerOutput**: *[StandardContractOutput](#class-standardcontractoutput)*

*Defined in [ethereum-types/src/index.ts:659](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L659)*

___

###  sourceCodes

• **sourceCodes**: *object*

*Defined in [ethereum-types/src/index.ts:655](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L655)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: string

___

###  sourceTreeHashHex

• **sourceTreeHashHex**: *string*

*Defined in [ethereum-types/src/index.ts:658](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L658)*

___

###  sources

• **sources**: *object*

*Defined in [ethereum-types/src/index.ts:650](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L650)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: object

<hr />

# Interface: DataItem


##   Properties

### `Optional` components

• **components**? : *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:138](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L138)*

___

### `Optional` internalType

• **internalType**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:137](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L137)*

___

###  name

• **name**: *string*

*Defined in [ethereum-types/src/index.ts:135](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L135)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:136](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L136)*

<hr />

# Interface: DecodedLogArgs


##  Type parameters

▪ **A**


##   Properties

###  address

• **address**: *string*

*Inherited from [LogEntry](#interface-logentry).[address](#address)*

*Defined in [ethereum-types/src/index.ts:435](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L435)*

___

###  args

• **args**: *`A`*

*Defined in [ethereum-types/src/index.ts:418](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L418)*

___

###  blockHash

• **blockHash**: *string | null*

*Inherited from [LogEntry](#interface-logentry).[blockHash](#blockhash)*

*Defined in [ethereum-types/src/index.ts:433](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L433)*

___

###  blockNumber

• **blockNumber**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[blockNumber](#blocknumber)*

*Defined in [ethereum-types/src/index.ts:434](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L434)*

___

###  data

• **data**: *string*

*Inherited from [LogEntry](#interface-logentry).[data](#data)*

*Defined in [ethereum-types/src/index.ts:436](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L436)*

___

###  event

• **event**: *string*

*Defined in [ethereum-types/src/index.ts:417](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L417)*

___

###  logIndex

• **logIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[logIndex](#logindex)*

*Defined in [ethereum-types/src/index.ts:430](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L430)*

___

###  topics

• **topics**: *string[]*

*Inherited from [LogEntry](#interface-logentry).[topics](#topics)*

*Defined in [ethereum-types/src/index.ts:437](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L437)*

___

###  transactionHash

• **transactionHash**: *string*

*Inherited from [LogEntry](#interface-logentry).[transactionHash](#transactionhash)*

*Defined in [ethereum-types/src/index.ts:432](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L432)*

___

###  transactionIndex

• **transactionIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[transactionIndex](#transactionindex)*

*Defined in [ethereum-types/src/index.ts:431](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L431)*

<hr />



# Interface: DevdocOutput


##   Properties

### `Optional` author

• **author**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:636](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L636)*

___

###  methods

• **methods**: *object*

*Defined in [ethereum-types/src/index.ts:637](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L637)*

#### Type declaration:

● \[▪ **signature**: *string*\]: object

___

### `Optional` title

• **title**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:635](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L635)*

<hr />

# Interface: EIP1193Provider


##   Properties

###  isEIP1193

• **isEIP1193**: *boolean*

*Defined in [ethereum-types/src/index.ts:73](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L73)*

## Methods

###  on

▸ **on**(`event`: [EIP1193Event](#eip1193event), `listener`: function): *this*

*Defined in [ethereum-types/src/index.ts:75](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L75)*

**Parameters:**

▪ **event**: *[EIP1193Event](#eip1193event)*

▪ **listener**: *function*

▸ (`result`: any): *void*

**Parameters:**

Name | Type |
------ | ------ |
`result` | any |

**Returns:** *this*

___

###  send

▸ **send**(`method`: string, `params?`: any[]): *`Promise<any>`*

*Defined in [ethereum-types/src/index.ts:74](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L74)*

**Parameters:**

Name | Type |
------ | ------ |
`method` | string |
`params?` | any[] |

**Returns:** *`Promise<any>`*

<hr />





# Interface: EvmBytecodeOutput


##   Properties

###  linkReferences

• **linkReferences**: *[EvmBytecodeOutputLinkReferences](#class-evmbytecodeoutputlinkreferences)*

*Defined in [ethereum-types/src/index.ts:623](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L623)*

___

###  object

• **object**: *string*

*Defined in [ethereum-types/src/index.ts:624](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L624)*

___

###  sourceMap

• **sourceMap**: *string*

*Defined in [ethereum-types/src/index.ts:625](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L625)*

<hr />

# Interface: EvmBytecodeOutputLinkReferences


##  Hierarchy

* **EvmOutput**


##  Properties

###  bytecode

• **bytecode**: *[EvmBytecodeOutput](#class-evmbytecodeoutput)*

*Defined in [ethereum-types/src/index.ts:618](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L618)*

___

###  deployedBytecode

• **deployedBytecode**: *[EvmBytecodeOutput](#class-evmbytecodeoutput)*

*Defined in [ethereum-types/src/index.ts:619](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L619)*

<hr />

# Interface: FallbackAbi


##   Properties

###  payable

• **payable**: *boolean*

*Defined in [ethereum-types/src/index.ts:112](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L112)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:111](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L111)*

<hr />



# Interface: GanacheProvider


##   Methods

###  sendAsync

▸ **sendAsync**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:14](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L14)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

<hr />



# Interface: JSONRPCRequestPayload


##   Properties

###  id

• **id**: *number*

*Defined in [ethereum-types/src/index.ts:331](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L331)*

___

###  jsonrpc

• **jsonrpc**: *string*

*Defined in [ethereum-types/src/index.ts:332](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L332)*

___

###  method

• **method**: *string*

*Defined in [ethereum-types/src/index.ts:330](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L330)*

___

###  params

• **params**: *any[]*

*Defined in [ethereum-types/src/index.ts:329](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L329)*

<hr />

# Interface: JSONRPCResponseError


##   Properties

###  code

• **code**: *number*

*Defined in [ethereum-types/src/index.ts:337](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L337)*

___

###  message

• **message**: *string*

*Defined in [ethereum-types/src/index.ts:336](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L336)*

<hr />

# Interface: JSONRPCResponsePayload


##   Properties

### `Optional` error

• **error**? : *[JSONRPCResponseError](#class-jsonrpcresponseerror)*

*Defined in [ethereum-types/src/index.ts:344](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L344)*

___

###  id

• **id**: *number*

*Defined in [ethereum-types/src/index.ts:342](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L342)*

___

###  jsonrpc

• **jsonrpc**: *string*

*Defined in [ethereum-types/src/index.ts:343](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L343)*

___

###  result

• **result**: *any*

*Defined in [ethereum-types/src/index.ts:341](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L341)*

<hr />





# Interface: LogWithDecodedArgs <**ArgsType**>

## Type parameters

▪ **ArgsType**: *[DecodedLogArgs](#class-decodedlogargs)*


##   Properties

###  address

• **address**: *string*

*Inherited from [LogEntry](#interface-logentry).[address](#address)*

*Defined in [ethereum-types/src/index.ts:435](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L435)*

___

###  args

• **args**: *`ArgsType`*

*Inherited from [DecodedLogEntry](#interface-decodedlogentry).[args](#args)*

*Defined in [ethereum-types/src/index.ts:418](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L418)*

___

###  blockHash

• **blockHash**: *string | null*

*Inherited from [LogEntry](#interface-logentry).[blockHash](#blockhash)*

*Defined in [ethereum-types/src/index.ts:433](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L433)*

___

###  blockNumber

• **blockNumber**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[blockNumber](#blocknumber)*

*Defined in [ethereum-types/src/index.ts:434](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L434)*

___

###  data

• **data**: *string*

*Inherited from [LogEntry](#interface-logentry).[data](#data)*

*Defined in [ethereum-types/src/index.ts:436](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L436)*

___

###  event

• **event**: *string*

*Inherited from [DecodedLogEntry](#interface-decodedlogentry).[event](#event)*

*Defined in [ethereum-types/src/index.ts:417](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L417)*

___

###  logIndex

• **logIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[logIndex](#logindex)*

*Defined in [ethereum-types/src/index.ts:430](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L430)*

___

###  topics

• **topics**: *string[]*

*Inherited from [LogEntry](#interface-logentry).[topics](#topics)*

*Defined in [ethereum-types/src/index.ts:437](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L437)*

___

###  transactionHash

• **transactionHash**: *string*

*Inherited from [LogEntry](#interface-logentry).[transactionHash](#transactionhash)*

*Defined in [ethereum-types/src/index.ts:432](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L432)*

___

###  transactionIndex

• **transactionIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[transactionIndex](#transactionindex)*

*Defined in [ethereum-types/src/index.ts:431](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L431)*

<hr />

# Interface: MethodAbi


##   Properties

###  constant

• **constant**: *boolean*

*Defined in [ethereum-types/src/index.ts:94](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L94)*

___

###  inputs

• **inputs**: *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:92](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L92)*

___

###  name

• **name**: *string*

*Defined in [ethereum-types/src/index.ts:91](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L91)*

___

###  outputs

• **outputs**: *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:93](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L93)*

___

###  payable

• **payable**: *boolean*

*Defined in [ethereum-types/src/index.ts:96](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L96)*

___

###  stateMutability

• **stateMutability**: *[StateMutability](#statemutability)*

*Defined in [ethereum-types/src/index.ts:95](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L95)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:90](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L90)*

<hr />

# Interface: OptimizerSettings


##   Properties

###  enabled

• **enabled**: *boolean*

*Defined in [ethereum-types/src/index.ts:716](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L716)*

___

### `Optional` runs

• **runs**? : *undefined | number*

*Defined in [ethereum-types/src/index.ts:717](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L717)*

<hr />





# Interface: RevertErrorAbi


##   Properties

### `Optional` arguments

• **arguments**? : *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:122](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L122)*

___

###  name

• **name**: *string*

*Defined in [ethereum-types/src/index.ts:121](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L121)*

___

###  type

• **type**: *"error"*

*Defined in [ethereum-types/src/index.ts:120](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L120)*

<hr />







# Interface: StandardContractOutput


##   Properties

###  abi

• **abi**: *[ContractAbi](#contractabi)*

*Defined in [ethereum-types/src/index.ts:565](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L565)*

___

### `Optional` devdoc

• **devdoc**? : *[DevdocOutput](#class-devdocoutput)*

*Defined in [ethereum-types/src/index.ts:567](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L567)*

___

###  evm

• **evm**: *[EvmOutput](#class-evmoutput)*

*Defined in [ethereum-types/src/index.ts:566](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L566)*

<hr />















# Interface: TupleDataItem


##   Properties

###  components

• **components**: *[DataItem](#class-dataitem)[]*

*Overrides [DataItem](_ethereum_types_src_index_.dataitem.md).[components](#optional-components)*

*Defined in [ethereum-types/src/index.ts:142](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L142)*

___

### `Optional` internalType

• **internalType**? : *undefined | string*

*Inherited from [DataItem](#interface-dataitem).[internalType](#optional-internaltype)*

*Defined in [ethereum-types/src/index.ts:137](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L137)*

___

###  name

• **name**: *string*

*Inherited from [DataItem](#interface-dataitem).[name](#name)*

*Defined in [ethereum-types/src/index.ts:135](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L135)*

___

###  type

• **type**: *string*

*Inherited from [DataItem](#interface-dataitem).[type](#type)*

*Defined in [ethereum-types/src/index.ts:136](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L136)*

<hr />

# Interface: TxData


##   Properties

### `Optional` data

• **data**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[data](#optional-data)*

*Defined in [ethereum-types/src/index.ts:394](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L394)*

___

###  from

• **from**: *string*

*Defined in [ethereum-types/src/index.ts:399](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L399)*

___

### `Optional` gas

• **gas**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gas](#optional-gas)*

*Defined in [ethereum-types/src/index.ts:392](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L392)*

___

### `Optional` gasPrice

• **gasPrice**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gasPrice](#optional-gasprice)*

*Defined in [ethereum-types/src/index.ts:393](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L393)*

___

### `Optional` nonce

• **nonce**? : *undefined | number*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[nonce](#optional-nonce)*

*Defined in [ethereum-types/src/index.ts:395](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L395)*

___

### `Optional` to

• **to**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[to](#optional-to)*

*Defined in [ethereum-types/src/index.ts:390](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L390)*

___

### `Optional` value

• **value**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[value](#optional-value)*

*Defined in [ethereum-types/src/index.ts:391](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L391)*

<hr />

# Interface: TxDataPayable


##   Properties

### `Optional` data

• **data**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[data](#optional-data)*

*Defined in [ethereum-types/src/index.ts:394](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L394)*

___

###  from

• **from**: *string*

*Inherited from [TxData](#interface-txdata).[from](#from)*

*Defined in [ethereum-types/src/index.ts:399](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L399)*

___

### `Optional` gas

• **gas**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gas](#optional-gas)*

*Defined in [ethereum-types/src/index.ts:392](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L392)*

___

### `Optional` gasPrice

• **gasPrice**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gasPrice](#optional-gasprice)*

*Defined in [ethereum-types/src/index.ts:393](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L393)*

___

### `Optional` nonce

• **nonce**? : *undefined | number*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[nonce](#optional-nonce)*

*Defined in [ethereum-types/src/index.ts:395](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L395)*

___

### `Optional` to

• **to**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[to](#optional-to)*

*Defined in [ethereum-types/src/index.ts:390](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L390)*

___

### `Optional` value

• **value**? : *`BigNumber`*

*Overrides [CallTxDataBase](_ethereum_types_src_index_.calltxdatabase.md).[value](#optional-value)*

*Defined in [ethereum-types/src/index.ts:443](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L443)*

<hr />

# Interface: Web3JsV1Provider

Web3.js version 1 provider interface
This provider interface was implemented in the pre-1.0Beta releases for Web3.js.
This interface allowed sending synchonous requests, support for which was later dropped.


##   Methods

###  send

▸ **send**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md)): *[JSONRPCResponsePayload](#class-jsonrpcresponsepayload)*

*Defined in [ethereum-types/src/index.ts:45](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L45)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |

**Returns:** *[JSONRPCResponsePayload](#class-jsonrpcresponsepayload)*

___

###  sendAsync

▸ **sendAsync**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:44](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L44)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

<hr />

# Interface: Web3JsV2Provider

Web3.js version 2 provider interface
This provider interface was used in a couple of Web3.js 1.0 beta releases
before the first attempts to conform to EIP1193


##   Methods

###  send

▸ **send**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:54](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L54)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

<hr />

# Interface: Web3JsV3Provider

Web3.js version 3 provider interface
This provider interface was implemented with the hopes for conforming to the EIP1193 spec,
however it does not conform entirely.


##   Methods

###  send

▸ **send**(`method`: string, `params?`: any[]): *`Promise<any>`*

*Defined in [ethereum-types/src/index.ts:63](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L63)*

**Parameters:**

Name | Type |
------ | ------ |
`method` | string |
`params?` | any[] |

**Returns:** *`Promise<any>`*

<hr />

# Interface: ZeroExProvider

The interface for the provider used internally by 0x libraries
Any property we use from any SupportedProvider should we explicitly
add here


##   Properties

### `Optional` isMetaMask

• **isMetaMask**? : *undefined | false | true*

*Defined in [ethereum-types/src/index.ts:31](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L31)*

___

### `Optional` isParity

• **isParity**? : *undefined | false | true*

*Defined in [ethereum-types/src/index.ts:32](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L32)*

___

### `Optional` isZeroExProvider

• **isZeroExProvider**? : *undefined | false | true*

*Defined in [ethereum-types/src/index.ts:30](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L30)*

## Methods

### `Optional` enable

▸ **enable**(): *`Promise<void>`*

*Defined in [ethereum-types/src/index.ts:34](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L34)*

**Returns:** *`Promise<void>`*

___

###  sendAsync

▸ **sendAsync**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:35](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L35)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

___

### `Optional` stop

▸ **stop**(): *void*

*Defined in [ethereum-types/src/index.ts:33](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L33)*

**Returns:** *void*

<hr />







# Interface: JSONRPCRequestPayloadWithMethod


##   Properties

###  id

• **id**: *number*



Defined in ethereum-types/lib/index.d.ts:268

___

###  jsonrpc

• **jsonrpc**: *string*



Defined in ethereum-types/lib/index.d.ts:269

___

###  method

• **method**: *string*

*Overrides void*

*Defined in [subproviders/src/types.ts:136](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/types.ts#L136)*

___

###  params

• **params**: *any[]*



Defined in ethereum-types/lib/index.d.ts:266

<hr />



















































# Interface: DecodedLogEvent <**ArgsType**>

## Type parameters

▪ **ArgsType**: *`DecodedLogArgs`*


##   Properties

###  isRemoved

• **isRemoved**: *boolean*

*Defined in [types/src/index.ts:848](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L848)*

___

###  log

• **log**: *`LogWithDecodedArgs<ArgsType>`*

*Defined in [types/src/index.ts:849](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L849)*

<hr />







# Interface: ECSignature

Elliptic Curve signature


##   Properties

###  r

• **r**: *string*

*Defined in [types/src/index.ts:62](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L62)*

___

###  s

• **s**: *string*

*Defined in [types/src/index.ts:63](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L63)*

___

###  v

• **v**: *number*

*Defined in [types/src/index.ts:61](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L61)*

<hr />

# Interface: EIP712DomainWithDefaultSchema


##   Properties

###  chainId

• **chainId**: *number*

*Defined in [types/src/index.ts:797](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L797)*

___

### `Optional` name

• **name**? : *undefined | string*

*Defined in [types/src/index.ts:795](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L795)*

___

###  verifyingContract

• **verifyingContract**: *string*

*Defined in [types/src/index.ts:798](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L798)*

___

### `Optional` version

• **version**? : *undefined | string*

*Defined in [types/src/index.ts:796](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L796)*

<hr />







# Interface: ERC1155AssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:190](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L190)*

___

###  callbackData

• **callbackData**: *string*

*Defined in [types/src/index.ts:194](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L194)*

___

###  tokenAddress

• **tokenAddress**: *string*

*Defined in [types/src/index.ts:191](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L191)*

___

###  tokenIds

• **tokenIds**: *`BigNumber`[]*

*Defined in [types/src/index.ts:192](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L192)*

___

###  tokenValues

• **tokenValues**: *`BigNumber`[]*

*Defined in [types/src/index.ts:193](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L193)*

<hr />



# Interface: ERC20AssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:172](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L172)*

___

###  tokenAddress

• **tokenAddress**: *string*

*Defined in [types/src/index.ts:173](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L173)*

<hr />

# Interface: ERC20BridgeAssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:177](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L177)*

___

###  bridgeAddress

• **bridgeAddress**: *string*

*Defined in [types/src/index.ts:179](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L179)*

___

###  bridgeData

• **bridgeData**: *string*

*Defined in [types/src/index.ts:180](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L180)*

___

###  tokenAddress

• **tokenAddress**: *string*

*Defined in [types/src/index.ts:178](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L178)*

<hr />

# Interface: ERC721AssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:184](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L184)*

___

###  tokenAddress

• **tokenAddress**: *string*

*Defined in [types/src/index.ts:185](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L185)*

___

###  tokenId

• **tokenId**: *`BigNumber`*

*Defined in [types/src/index.ts:186](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L186)*

<hr />





 





# Interface: IndexedFilterValues


##  Hierarchy

* **IndexSignature**


##  Properties

###  keyName

• **keyName**: *string*

*Defined in [types/src/index.ts:695](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L695)*

___

###  keyType

• **keyType**: *[Type](#class-type)*

*Defined in [types/src/index.ts:696](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L696)*

___

###  valueName

• **valueName**: *string*

*Defined in [types/src/index.ts:697](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L697)*

<hr />





# Interface: MultiAssetData


##   Properties

###  amounts

• **amounts**: *`BigNumber`[]*

*Defined in [types/src/index.ts:220](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L220)*

___

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:219](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L219)*

___

###  nestedAssetData

• **nestedAssetData**: *string[]*

*Defined in [types/src/index.ts:221](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L221)*

<hr />

# Interface: MultiAssetDataWithRecursiveDecoding


##   Properties

###  amounts

• **amounts**: *`BigNumber`[]*

*Defined in [types/src/index.ts:226](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L226)*

___

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:225](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L225)*

___

###  nestedAssetData

• **nestedAssetData**: *[SingleAssetData](#singleassetdata)[]*

*Defined in [types/src/index.ts:227](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L227)*

<hr />





































# Interface: SignedOrder


##   Properties

###  chainId

• **chainId**: *number*

*Inherited from [Order](#interface-order).[chainId](#chainid)*

*Defined in [types/src/index.ts:14](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L14)*

___

###  exchangeAddress

• **exchangeAddress**: *string*

*Inherited from [Order](#interface-order).[exchangeAddress](#exchangeaddress)*

*Defined in [types/src/index.ts:15](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L15)*

___

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Inherited from [Order](#interface-order).[expirationTimeSeconds](#expirationtimeseconds)*

*Defined in [types/src/index.ts:24](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L24)*

___

###  feeRecipientAddress

• **feeRecipientAddress**: *string*

*Inherited from [Order](#interface-order).[feeRecipientAddress](#feerecipientaddress)*

*Defined in [types/src/index.ts:18](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L18)*

___

###  makerAddress

• **makerAddress**: *string*

*Inherited from [Order](#interface-order).[makerAddress](#makeraddress)*

*Defined in [types/src/index.ts:16](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L16)*

___

###  makerAssetAmount

• **makerAssetAmount**: *`BigNumber`*

*Inherited from [Order](#interface-order).[makerAssetAmount](#makerassetamount)*

*Defined in [types/src/index.ts:20](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L20)*

___

###  makerAssetData

• **makerAssetData**: *string*

*Inherited from [Order](#interface-order).[makerAssetData](#makerassetdata)*

*Defined in [types/src/index.ts:26](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L26)*

___

###  makerFee

• **makerFee**: *`BigNumber`*

*Inherited from [Order](#interface-order).[makerFee](#makerfee)*

*Defined in [types/src/index.ts:22](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L22)*

___

###  makerFeeAssetData

• **makerFeeAssetData**: *string*

*Inherited from [Order](#interface-order).[makerFeeAssetData](#makerfeeassetdata)*

*Defined in [types/src/index.ts:28](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L28)*

___

###  salt

• **salt**: *`BigNumber`*

*Inherited from [Order](#interface-order).[salt](#salt)*

*Defined in [types/src/index.ts:25](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L25)*

___

###  senderAddress

• **senderAddress**: *string*

*Inherited from [Order](#interface-order).[senderAddress](#senderaddress)*

*Defined in [types/src/index.ts:19](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L19)*

___

###  signature

• **signature**: *string*

*Defined in [types/src/index.ts:33](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L33)*

___

###  takerAddress

• **takerAddress**: *string*

*Inherited from [Order](#interface-order).[takerAddress](#takeraddress)*

*Defined in [types/src/index.ts:17](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L17)*

___

###  takerAssetAmount

• **takerAssetAmount**: *`BigNumber`*

*Inherited from [Order](#interface-order).[takerAssetAmount](#takerassetamount)*

*Defined in [types/src/index.ts:21](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L21)*

___

###  takerAssetData

• **takerAssetData**: *string*

*Inherited from [Order](#interface-order).[takerAssetData](#takerassetdata)*

*Defined in [types/src/index.ts:27](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L27)*

___

###  takerFee

• **takerFee**: *`BigNumber`*

*Inherited from [Order](#interface-order).[takerFee](#takerfee)*

*Defined in [types/src/index.ts:23](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L23)*

___

###  takerFeeAssetData

• **takerFeeAssetData**: *string*

*Inherited from [Order](#interface-order).[takerFeeAssetData](#takerfeeassetdata)*

*Defined in [types/src/index.ts:29](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L29)*

<hr />

# Interface: SignedZeroExTransaction


##   Properties

###  data

• **data**: *string*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[data](#data)*

*Defined in [types/src/index.ts:49](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L49)*

___

###  domain

• **domain**: *[EIP712DomainWithDefaultSchema](#class-eip712domainwithdefaultschema)*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[domain](#domain)*

*Defined in [types/src/index.ts:50](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L50)*

___

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[expirationTimeSeconds](#expirationtimeseconds)*

*Defined in [types/src/index.ts:46](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L46)*

___

###  gasPrice

• **gasPrice**: *`BigNumber`*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[gasPrice](#gasprice)*

*Defined in [types/src/index.ts:47](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L47)*

___

###  salt

• **salt**: *`BigNumber`*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[salt](#salt)*

*Defined in [types/src/index.ts:45](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L45)*

___

###  signature

• **signature**: *string*

*Defined in [types/src/index.ts:54](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L54)*

___

###  signerAddress

• **signerAddress**: *string*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[signerAddress](#signeraddress)*

*Defined in [types/src/index.ts:48](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L48)*

<hr />

# Interface: SimpleContractArtifact


##   Properties

###  chains

• **chains**: *`ContractChains`*

*Defined in [types/src/index.ts:865](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L865)*

___

###  compilerOutput

• **compilerOutput**: *[SimpleStandardContractOutput](#class-simplestandardcontractoutput)*

*Defined in [types/src/index.ts:864](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L864)*

___

###  contractName

• **contractName**: *string*

*Defined in [types/src/index.ts:863](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L863)*

___

###  schemaVersion

• **schemaVersion**: *string*

*Defined in [types/src/index.ts:862](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L862)*

<hr />

# Interface: SimpleEvmBytecodeOutput


##   Properties

###  object

• **object**: *string*

*Defined in [types/src/index.ts:879](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L879)*

<hr />

# Interface: SimpleEvmOutput


##   Properties

###  bytecode

• **bytecode**: *[SimpleEvmBytecodeOutput](#class-simpleevmbytecodeoutput)*

*Defined in [types/src/index.ts:875](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L875)*

<hr />

# Interface: SimpleStandardContractOutput


##   Properties

###  abi

• **abi**: *[ContractAbi](#contractabi)*

*Defined in [types/src/index.ts:869](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L869)*

___

### `Optional` devdoc

• **devdoc**? : *[DevdocOutput](#class-devdocoutput)*

*Defined in [types/src/index.ts:871](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L871)*

___

###  evm

• **evm**: *[SimpleEvmOutput](#class-simpleevmoutput)*

*Defined in [types/src/index.ts:870](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L870)*

<hr />





# Interface: StaticCallAssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:198](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L198)*

___

###  callResultHash

• **callResultHash**: *string*

*Defined in [types/src/index.ts:201](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L201)*

___

###  callTarget

• **callTarget**: *string*

*Defined in [types/src/index.ts:199](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L199)*

___

###  staticCallData

• **staticCallData**: *string*

*Defined in [types/src/index.ts:200](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L200)*

<hr />



























# Interface: ValidatorSignature

Validator signature components


##   Properties

###  signature

• **signature**: *string*

*Defined in [types/src/index.ts:71](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L71)*

___

###  validatorAddress

• **validatorAddress**: *string*

*Defined in [types/src/index.ts:70](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L70)*

<hr />

# Interface: ZeroExTransaction

ZeroExTransaction for use with 0x Exchange executeTransaction


##   Properties

###  data

• **data**: *string*

*Defined in [types/src/index.ts:49](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L49)*

___

###  domain

• **domain**: *[EIP712DomainWithDefaultSchema](#class-eip712domainwithdefaultschema)*

*Defined in [types/src/index.ts:50](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L50)*

___

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Defined in [types/src/index.ts:46](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L46)*

___

###  gasPrice

• **gasPrice**: *`BigNumber`*

*Defined in [types/src/index.ts:47](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L47)*

___

###  salt

• **salt**: *`BigNumber`*

*Defined in [types/src/index.ts:45](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L45)*

___

###  signerAddress

• **signerAddress**: *string*

*Defined in [types/src/index.ts:48](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L48)*

<hr />




##  Type aliases






##  Functions

###  getContractAddressesForChainOrThrow

▸ **getContractAddressesForChainOrThrow**(`chainId`: [ChainId](#enumeration-chainid)): *[ContractAddresses](#interface-contractaddresses)*

*Defined in [contract-addresses/src/index.ts:50](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-addresses/src/index.ts#L50)*

Used to get addresses of contracts that have been deployed to either the
Ethereum mainnet or a supported testnet. Throws if there are no known
contracts deployed on the corresponding chain.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`chainId` | [ChainId](#enumeration-chainid) | The desired chainId. |

**Returns:** *[ContractAddresses](#interface-contractaddresses)*

The set of addresses for contracts which have been deployed on the
given chainId.

<hr />



<hr /> 




##  Type aliases

###  ERC20TokenEventArgs

Ƭ **ERC20TokenEventArgs**: *[ERC20TokenApprovalEventArgs](#interface-erc20tokenapprovaleventargs) | [ERC20TokenTransferEventArgs](#interface-erc20tokentransfereventargs)*

*Defined in [contract-wrappers/src/generated-wrappers/erc20_token.ts:38](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc20_token.ts#L38)*

<hr />




##  Type aliases

###  ERC721TokenEventArgs

Ƭ **ERC721TokenEventArgs**: *[ERC721TokenApprovalEventArgs](#interface-erc721tokenapprovaleventargs) | [ERC721TokenApprovalForAllEventArgs](#interface-erc721tokenapprovalforalleventargs) | [ERC721TokenTransferEventArgs](#interface-erc721tokentransfereventargs)*

*Defined in [contract-wrappers/src/generated-wrappers/erc721_token.ts:38](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/erc721_token.ts#L38)*

<hr />




##  Type aliases

###  ExchangeEventArgs

Ƭ **ExchangeEventArgs**: *[ExchangeAssetProxyRegisteredEventArgs](#interface-exchangeassetproxyregisteredeventargs) | [ExchangeCancelEventArgs](#interface-exchangecanceleventargs) | [ExchangeCancelUpToEventArgs](#interface-exchangecanceluptoeventargs) | [ExchangeFillEventArgs](#interface-exchangefilleventargs) | [ExchangeOwnershipTransferredEventArgs](#interface-exchangeownershiptransferredeventargs) | [ExchangeProtocolFeeCollectorAddressEventArgs](#interface-exchangeprotocolfeecollectoraddresseventargs) | [ExchangeProtocolFeeMultiplierEventArgs](#interface-exchangeprotocolfeemultipliereventargs) | [ExchangeSignatureValidatorApprovalEventArgs](#interface-exchangesignaturevalidatorapprovaleventargs) | [ExchangeTransactionExecutionEventArgs](#interface-exchangetransactionexecutioneventargs)*

*Defined in [contract-wrappers/src/generated-wrappers/exchange.ts:38](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/exchange.ts#L38)*

<hr />




##  Type aliases

###  WETH9EventArgs

Ƭ **WETH9EventArgs**: *[WETH9ApprovalEventArgs](#interface-weth9approvaleventargs) | [WETH9DepositEventArgs](#interface-weth9depositeventargs) | [WETH9TransferEventArgs](#interface-weth9transfereventargs) | [WETH9WithdrawalEventArgs](#interface-weth9withdrawaleventargs)*

*Defined in [contract-wrappers/src/generated-wrappers/weth9.ts:38](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/contract-wrappers/src/generated-wrappers/weth9.ts#L38)*

<hr />




##  Type aliases

###  AbiDefinition

Ƭ **AbiDefinition**: *[FunctionAbi](_ethereum_types_src_index_.md#functionabi) | [EventAbi](#interface-eventabi) | [RevertErrorAbi](#interface-reverterrorabi)*

*Defined in [ethereum-types/src/index.ts:80](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L80)*

___

###  BlockParam

Ƭ **BlockParam**: *[BlockParamLiteral](#enumeration-blockparamliteral) | number*

*Defined in [ethereum-types/src/index.ts:484](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L484)*

___

###  ConstructorStateMutability

Ƭ **ConstructorStateMutability**: *"nonpayable" | "payable"*

*Defined in [ethereum-types/src/index.ts:84](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L84)*

___

###  ContractAbi

Ƭ **ContractAbi**: *[AbiDefinition](#abidefinition)[]*

*Defined in [ethereum-types/src/index.ts:78](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L78)*

___

###  ContractEventArg

Ƭ **ContractEventArg**: *any*

*Defined in [ethereum-types/src/index.ts:469](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L469)*

___



###  EIP1193Event

Ƭ **EIP1193Event**: *"accountsChanged" | "networkChanged" | "close" | "connect" | "notification"*

*Defined in [ethereum-types/src/index.ts:70](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L70)*

Interface for providers that conform to EIP 1193
Source: https://github.com/ethereum/EIPs/blob/master/EIPS/eip-1193.md

___





###  FunctionAbi

Ƭ **FunctionAbi**: *[MethodAbi](#interface-methodabi) | [ConstructorAbi](#interface-constructorabi) | [FallbackAbi](#interface-fallbackabi)*

*Defined in [ethereum-types/src/index.ts:82](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L82)*

___

###  JSONRPCErrorCallback

Ƭ **JSONRPCErrorCallback**: *function*

*Defined in [ethereum-types/src/index.ts:3](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L3)*

#### Type declaration:

▸ (`err`: `Error` | null, `result?`: [JSONRPCResponsePayload](#interface-jsonrpcresponsepayload)): *void*

**Parameters:**

Name | Type |
------ | ------ |
`err` | `Error` \| null |
`result?` | [JSONRPCResponsePayload](#interface-jsonrpcresponsepayload) |

___



###  OutputField

Ƭ **OutputField**: *"*" | "ast" | "legacyAST" | "abi" | "devdoc" | "userdoc" | "metadata" | "ir" | "evm.assembly" | "evm.legacyAssembly" | "evm.bytecode.object" | "evm.bytecode.opcodes" | "evm.bytecode.sourceMap" | "evm.bytecode.linkReferences" | "evm.deployedBytecode.object" | "evm.deployedBytecode.opcodes" | "evm.deployedBytecode.sourceMap" | "evm.deployedBytecode.linkReferences" | "evm.methodIdentifiers" | "evm.gasEstimates" | "ewasm.wast" | "ewasm.wasm"*

*Defined in [ethereum-types/src/index.ts:526](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L526)*

___

###  ParamDescription

Ƭ **ParamDescription**: *string*

*Defined in [ethereum-types/src/index.ts:562](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L562)*

___



###  StateMutability

Ƭ **StateMutability**: *"pure" | "view" | [ConstructorStateMutability](#constructorstatemutability)*

*Defined in [ethereum-types/src/index.ts:85](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L85)*

___

###  SupportedProvider

Ƭ **SupportedProvider**: *[Web3JsProvider](_ethereum_types_src_index_.md#web3jsprovider) | [GanacheProvider](#interface-ganacheprovider) | [EIP1193Provider](#interface-eip1193provider) | [ZeroExProvider](#interface-zeroexprovider)*

*Defined in [ethereum-types/src/index.ts:9](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L9)*

Do not create your own provider. Use an existing provider from a Web3 or ProviderEngine library
Read more about Providers in the guides section of the 0x docs.

___





###  Web3JsProvider

Ƭ **Web3JsProvider**: *[Web3JsV1Provider](#interface-web3jsv1provider) | [Web3JsV2Provider](#interface-web3jsv2provider) | [Web3JsV3Provider](#interface-web3jsv3provider)*

*Defined in [ethereum-types/src/index.ts:11](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/ethereum-types/src/index.ts#L11)*

<hr />




##  Object literals

### `Const` assetDataUtils

#### ▪ **assetDataUtils**: *object*

*Defined in [order-utils/src/asset_data_utils.ts:20](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L20)*

####  decodeAssetDataOrThrow

▸ **decodeAssetDataOrThrow**(`assetData`: string): *[AssetData](#assetdata)*

*Defined in [order-utils/src/asset_data_utils.ts:57](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L57)*

Decode any assetData into its corresponding assetData object

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *[AssetData](#assetdata)*

Either a ERC20, ERC20Bridge, ERC721, ERC1155, StaticCall, or MultiAsset assetData object

####  decodeMultiAssetDataRecursively

▸ **decodeMultiAssetDataRecursively**(`assetData`: string): *`MultiAssetDataWithRecursiveDecoding`*

*Defined in [order-utils/src/asset_data_utils.ts:138](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L138)*

Decodes a MultiAsset assetData hex string into its corresponding amounts and decoded nestedAssetData elements (all nested elements are flattened)

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`MultiAssetDataWithRecursiveDecoding`*

An object containing the decoded amounts and nestedAssetData

####  encodeERC1155AssetData

▸ **encodeERC1155AssetData**(`tokenAddress`: string, `tokenIds`: `BigNumber`[], `tokenValues`: `BigNumber`[], `callbackData`: string): *string*

*Defined in [order-utils/src/asset_data_utils.ts:30](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L30)*

**Parameters:**

Name | Type |
------ | ------ |
`tokenAddress` | string |
`tokenIds` | `BigNumber`[] |
`tokenValues` | `BigNumber`[] |
`callbackData` | string |

**Returns:** *string*

####  encodeERC20AssetData

▸ **encodeERC20AssetData**(`tokenAddress`: string): *string*

*Defined in [order-utils/src/asset_data_utils.ts:21](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L21)*

**Parameters:**

Name | Type |
------ | ------ |
`tokenAddress` | string |

**Returns:** *string*

####  encodeERC20BridgeAssetData

▸ **encodeERC20BridgeAssetData**(`tokenAddress`: string, `bridgeAddress`: string, `bridgeData`: string): *string*

*Defined in [order-utils/src/asset_data_utils.ts:24](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L24)*

**Parameters:**

Name | Type |
------ | ------ |
`tokenAddress` | string |
`bridgeAddress` | string |
`bridgeData` | string |

**Returns:** *string*

####  encodeERC721AssetData

▸ **encodeERC721AssetData**(`tokenAddress`: string, `tokenId`: `BigNumber`): *string*

*Defined in [order-utils/src/asset_data_utils.ts:27](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L27)*

**Parameters:**

Name | Type |
------ | ------ |
`tokenAddress` | string |
`tokenId` | `BigNumber` |

**Returns:** *string*

####  encodeMultiAssetData

▸ **encodeMultiAssetData**(`values`: `BigNumber`[], `nestedAssetData`: string[]): *string*

*Defined in [order-utils/src/asset_data_utils.ts:40](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L40)*

**Parameters:**

Name | Type |
------ | ------ |
`values` | `BigNumber`[] |
`nestedAssetData` | string[] |

**Returns:** *string*

####  encodeStaticCallAssetData

▸ **encodeStaticCallAssetData**(`staticCallTargetAddress`: string, `staticCallData`: string, `expectedReturnDataHash`: string): *string*

*Defined in [order-utils/src/asset_data_utils.ts:43](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L43)*

**Parameters:**

Name | Type |
------ | ------ |
`staticCallTargetAddress` | string |
`staticCallData` | string |
`expectedReturnDataHash` | string |

**Returns:** *string*

####  isERC1155TokenAssetData

▸ **isERC1155TokenAssetData**(`assetData`: [AssetData](#assetdata)): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:176](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L176)*

**Parameters:**

Name | Type |
------ | ------ |
`assetData` | [AssetData](#assetdata) |

**Returns:** *boolean*

####  isERC20BridgeAssetData

▸ **isERC20BridgeAssetData**(`assetData`: [AssetData](#assetdata)): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:173](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L173)*

**Parameters:**

Name | Type |
------ | ------ |
`assetData` | [AssetData](#assetdata) |

**Returns:** *boolean*

####  isERC20TokenAssetData

▸ **isERC20TokenAssetData**(`assetData`: [AssetData](#assetdata)): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:170](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L170)*

**Parameters:**

Name | Type |
------ | ------ |
`assetData` | [AssetData](#assetdata) |

**Returns:** *boolean*

####  isERC721TokenAssetData

▸ **isERC721TokenAssetData**(`assetData`: [AssetData](#assetdata)): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:179](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L179)*

**Parameters:**

Name | Type |
------ | ------ |
`assetData` | [AssetData](#assetdata) |

**Returns:** *boolean*

####  isMultiAssetData

▸ **isMultiAssetData**(`assetData`: [AssetData](#assetdata)): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:182](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L182)*

**Parameters:**

Name | Type |
------ | ------ |
`assetData` | [AssetData](#assetdata) |

**Returns:** *boolean*

####  isStaticCallAssetData

▸ **isStaticCallAssetData**(`assetData`: [AssetData](#assetdata)): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:185](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/asset_data_utils.ts#L185)*

**Parameters:**

Name | Type |
------ | ------ |
`assetData` | [AssetData](#assetdata) |

**Returns:** *boolean*

<hr />




##  Functions

####  generatePseudoRandomSalt

▸ **generatePseudoRandomSalt**(): *`BigNumber`*

*Defined in [order-utils/src/salt.ts:9](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/salt.ts#L9)*

Generates a pseudo-random 256-bit salt.
The salt can be included in a 0x order, ensuring that the order generates a unique orderHash
and will not collide with other outstanding orders that are identical in all other parameters.

**Returns:** *`BigNumber`*

A pseudo-random 256-bit number that can be used as a salt.

<hr />




##  Functions

####  isValidECSignature

▸ **isValidECSignature**(`data`: string, `signature`: `ECSignature`, `signerAddress`: string): *boolean*

*Defined in [order-utils/src/signature_utils.ts:342](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L342)*

Checks if the supplied elliptic curve signature corresponds to signing `data` with
the private key corresponding to `signerAddress`

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`data` | string | The hex encoded data signed by the supplied signature. |
`signature` | `ECSignature` | An object containing the elliptic curve signature parameters. |
`signerAddress` | string | The hex encoded address that signed the data, producing the supplied signature. |

**Returns:** *boolean*

Whether the ECSignature is valid.

___

###  parseSignatureHexAsVRS

▸ **parseSignatureHexAsVRS**(`signatureHex`: string): *`ECSignature`*

*Defined in [order-utils/src/signature_utils.ts:300](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L300)*

Parses a signature hex string, which is assumed to be in the VRS format.

**Parameters:**

Name | Type |
------ | ------ |
`signatureHex` | string |

**Returns:** *`ECSignature`*

## Object literals

### `Const` signatureUtils

#### ▪ **signatureUtils**: *object*

*Defined in [order-utils/src/signature_utils.ts:23](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L23)*

####  addSignedMessagePrefix

▸ **addSignedMessagePrefix**(`message`: string): *string*

*Defined in [order-utils/src/signature_utils.ts:273](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L273)*

Adds the relevant prefix to the message being signed.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`message` | string | Message to sign |

**Returns:** *string*

Prefixed message

####  convertECSignatureToSignatureHex

▸ **convertECSignatureToSignatureHex**(`ecSignature`: `ECSignature`): *string*

*Defined in [order-utils/src/signature_utils.ts:247](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L247)*

Combines ECSignature with V,R,S and the EthSign signature type for use in 0x protocol

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ecSignature` | `ECSignature` | The ECSignature of the signed data |

**Returns:** *string*

Hex encoded string of signature (v,r,s) with Signature Type

####  convertToSignatureWithType

▸ **convertToSignatureWithType**(`signature`: string, `signatureType`: `SignatureType`): *string*

*Defined in [order-utils/src/signature_utils.ts:263](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L263)*

Combines the signature proof and the Signature Type.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`signature` | string | The hex encoded signature proof |
`signatureType` | `SignatureType` | The signature type, i.e EthSign, Wallet etc. |

**Returns:** *string*

Hex encoded string of signature proof with Signature Type

####  ecSignHashAsync

▸ **ecSignHashAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `msgHash`: string, `signerAddress`: string): *`Promise<string>`*

*Defined in [order-utils/src/signature_utils.ts:198](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L198)*

Signs a hash using `eth_sign` and returns its elliptic curve signature and signature type.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`msgHash` | string | Hex encoded message to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<string>`*

A hex encoded string containing the Elliptic curve signature generated by signing the msgHash and the Signature Type.

####  ecSignOrderAsync

▸ **ecSignOrderAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `order`: `Order`, `signerAddress`: string): *`Promise<SignedOrder>`*

*Defined in [order-utils/src/signature_utils.ts:33](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L33)*

Signs an order and returns a SignedOrder. First `eth_signTypedData` is requested
then a fallback to `eth_sign` if not available on the supplied provider.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`order` | `Order` | The Order to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedOrder>`*

A SignedOrder containing the order and Elliptic curve signature with Signature Type.

####  ecSignTransactionAsync

▸ **ecSignTransactionAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `transaction`: `ZeroExTransaction`, `signerAddress`: string): *`Promise<SignedZeroExTransaction>`*

*Defined in [order-utils/src/signature_utils.ts:112](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L112)*

Signs a transaction and returns a SignedZeroExTransaction. First `eth_signTypedData` is requested
then a fallback to `eth_sign` if not available on the supplied provider.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`transaction` | `ZeroExTransaction` | The ZeroExTransaction to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedZeroExTransaction>`*

A SignedTransaction containing the order and Elliptic curve signature with Signature Type.

####  ecSignTypedDataOrderAsync

▸ **ecSignTypedDataOrderAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `order`: `Order`, `signerAddress`: string): *`Promise<SignedOrder>`*

*Defined in [order-utils/src/signature_utils.ts:68](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L68)*

Signs an order using `eth_signTypedData` and returns a SignedOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`order` | `Order` | The Order to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedOrder>`*

A SignedOrder containing the order and Elliptic curve signature with Signature Type.

####  ecSignTypedDataTransactionAsync

▸ **ecSignTypedDataTransactionAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `transaction`: `ZeroExTransaction`, `signerAddress`: string): *`Promise<SignedZeroExTransaction>`*

*Defined in [order-utils/src/signature_utils.ts:155](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L155)*

Signs a ZeroExTransaction using `eth_signTypedData` and returns a SignedZeroExTransaction.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`transaction` | `ZeroExTransaction` | The ZeroEx Transaction to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedZeroExTransaction>`*

A SignedZeroExTransaction containing the ZeroExTransaction and Elliptic curve signature with Signature Type.

####  parseValidatorSignature

▸ **parseValidatorSignature**(`signature`: string): *`ValidatorSignature`*

*Defined in [order-utils/src/signature_utils.ts:285](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/order-utils/src/signature_utils.ts#L285)*

Parse a hex-encoded Validator signature into validator address and signature components

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`signature` | string | A hex encoded Validator 0x Protocol signature |

**Returns:** *`ValidatorSignature`*

A ValidatorSignature with validatorAddress and signature parameters

<hr />



<hr /> 



<hr /> 




##  Type aliases

####  Callback

Ƭ **Callback**: *function*

*Defined in [subproviders/src/types.ts:131](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/types.ts#L131)*

##### Type declaration:

▸ (): *void*

___



###  ErrorCallback

Ƭ **ErrorCallback**: *function*

*Defined in [subproviders/src/types.ts:130](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/subproviders/src/types.ts#L130)*

#### Type declaration:

▸ (`err`: `Error` | null, `data?`: any): *void*

**Parameters:**

Name | Type |
------ | ------ |
`err` | `Error` \| null |
`data?` | any |

___










##  Type aliases



###  AssetData

Ƭ **AssetData**: *[SingleAssetData](_types_src_index_.md#singleassetdata) | [MultiAssetData](#interface-multiassetdata) | [MultiAssetDataWithRecursiveDecoding](#interface-multiassetdatawithrecursivedecoding)*

*Defined in [types/src/index.ts:236](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L236)*

___







###  EventCallback

Ƭ **EventCallback**: *function*

*Defined in [types/src/index.ts:852](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L852)*

#### Type declaration:

▸ (`err`: null | `Error`, `log?`: [DecodedLogEvent](#interface-decodedlogevent)‹*`ArgsType`*›): *void*

**Parameters:**

Name | Type |
------ | ------ |
`err` | null \| `Error` |
`log?` | [DecodedLogEvent](#interface-decodedlogevent)‹*`ArgsType`*› |

___









###  SingleAssetData

Ƭ **SingleAssetData**: *[ERC20AssetData](#interface-erc20assetdata) | [ERC20BridgeAssetData](#interface-erc20bridgeassetdata) | [ERC721AssetData](#interface-erc721assetdata) | [ERC1155AssetData](#interface-erc1155assetdata) | [StaticCallAssetData](#interface-staticcallassetdata)*

*Defined in [types/src/index.ts:211](https://github.com/0xProject/0x-monorepo/blob/be7b1a1bd/packages/types/src/index.ts#L211)*

<hr />



<hr />

